//------------------------------------------------------------------------------
// MsgMap.js  
// Messages to fields mapping 
//------------------------------------------------------------------------------


function MsgMap()
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _oMap   = new Object();  // The "HashMap" (void)
	
	//==============================================================================
	// PUBLIC METHODS 
	//==============================================================================
	//------------------------------------------------------------------------------
	// Map a message code to a field id
	//------------------------------------------------------------------------------
	this.map = function(sMsgCode, sFieldId) 
	{
		_oMap[sMsgCode] = sFieldId ;
	}
	//------------------------------------------------------------------------------
	// Return the field id mapped with the given message code (or null if none)
	//------------------------------------------------------------------------------
	this.getFieldId = function(sMsgCode) 
	{
		return _oMap[sMsgCode] ;
	}
	//------------------------------------------------------------------------------
	// Show a single field message
	//------------------------------------------------------------------------------
	this.showFieldMessage = function(oMsg, sFieldId) 
	{
		Tools.fieldMessage(sFieldId, oMsg.getText() );
	}
	//------------------------------------------------------------------------------
	// Show a single global message
	//------------------------------------------------------------------------------
	this.showGlobalMessage = function(oMsg) 
	{
		alert ( "Global message :\n" + oMsg.getCode() + " : " + oMsg.getText() ) ;
	}
	//------------------------------------------------------------------------------
	// Show a single message
	//------------------------------------------------------------------------------
	this.showMessage = function(oMsg) 
	{
		var sMsgCode = oMsg.getCode();
		var sFieldId = _oMap[sMsgCode] ;
		if ( sFieldId != null )
		{
			//--- Field message
			this.showFieldMessage(oMsg, sFieldId );
		}
		else
		{
			//--- Global message
			this.showGlobalMessage(oMsg);
		}
	}
	//------------------------------------------------------------------------------
	// Show each message of the array
	//------------------------------------------------------------------------------
	this.showMessages = function( arrayMsg ) 
	{
		if ( arrayMsg == null ) // No message list to show
		{
			return ;
		}

		if ( arrayMsg.length == null )
		{
			alert ( "Error: MsgMap.showMessages() : argument is not an array ! " );
			return ;
		}
		
		var msg = null ;
		for ( var i = 0 ; i < arrayMsg.length ; i++ )
		{
			//alert("message[" + i + "]");
			msg = arrayMsg[i] ;
			if ( msg != null )
			{
				this.showMessage(msg);
			}
		}
	}
	//------------------------------------------------------------------------------
}	
