//------------------------------------------------------------------------------
// Popup.js  
// Functions set to managed the popup windows
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Open a popup window
//------------------------------------------------------------------------------
function fwkOpenPopupWindow(argUrl, callback, argWidth, argHeight)
{
	var sUrl = argUrl ;

	//--- Set the standard accessors functions to the current window 
	window.fwkSetPopupReturnObject = function ( oReturn ) 
	{
		//alert("fwkSetPopupReturnObject(" + oReturn + ")" );
		if ( callback )
		{
			callback( oReturn );
		}
		window.fwkPopupReturnObject = oReturn ;
	}
	
	//--- Open the popup window 
	if ( window.showModalDialog )
	{
		//--- IE => use "showModalDialog" with return
		var dialogArguments = "xx" ; // used as a flag to identify IE modal dialog
		var sWindowFeatures = "center:yes;" ;
		if ( argWidth )  sWindowFeatures += "dialogWidth:"  + argWidth + "px;" ;
		if ( argHeight ) sWindowFeatures += "dialogHeight:" + argHeight + "px;" ;
    	var oReturn = window.showModalDialog(sUrl, dialogArguments, sWindowFeatures );
    	window.fwkSetPopupReturnObject(oReturn);
	}
	else
	{
		//--- Non IE => use "open"
		var sWindowName = "Popup"  ;
		//var sWindowFeatures = "resizable=no,scrollbars=no,status=no,toolbar=no,location=no" ;
		//var sWindowFeatures = "dialog=yes,dependent=yes,status=no,width=400,height=400" ; // for Firefox modal window
		var sWindowFeatures = "dialog=yes,dependent=yes,status=no," ; // for Firefox modal window
		if ( argWidth  == null ) argWidth  = 400 ;
		if ( argHeight == null ) argHeight = 400 ;
		sWindowFeatures += "width=" + argWidth + ",height=" + argHeight + ",";
		//--- Open or focus
		if ( window.popupWindow == null )
		{
			window.popupWindow = window.open(sUrl, sWindowName, sWindowFeatures );
		}
		else
		{
			if ( window.popupWindow.closed )
			{
				window.popupWindow = window.open(sUrl, sWindowName, sWindowFeatures);
			}
		}
		window.popupWindow.focus();
	}
}

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
function fwkPopupReturn( oReturn )
{
	if ( window.opener )
	{
		if ( window.opener.fwkSetPopupReturnObject )
		{
			window.opener.fwkSetPopupReturnObject(oReturn);
		}
		else
		{
			alert("ERROR : window.opener.fwkSetPopupReturnObject is not defined ! ");
		}
	}
	else
	{
		if ( window.dialogArguments )
		{
			//--- It's an IE modal dialog box
			window.returnValue = oReturn ;
		}
		else
		{
			alert("ERROR : window.opener and window.dialogArguments  not defined ! ");
		}
	}
	window.close();
}
//------------------------------------------------------------------------------
