//----------------------------------------------------------------------------------------------------
// fwkCommon.js
//----------------------------------------------------------------------------------------------------
function fwkGetField(sId)
{
	var oField = document.getElementById(sId) ; 
	if ( oField == null )
	{
		alert("ERROR : Cannot found object for id "+sId ) ;
	}
	return oField ;
}
//----------------------------------------------------------------------------------------------------
function fwkSetChecked(sId, bStatus)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		if ( oField.tagName == 'INPUT' && ( oField.type == "checkbox" || oField.type == "radio" ) ) 
		{
			oField.checked = bStatus ;
		}
		else
		{
			alert( "ERROR : " + sId + " is not a checkbox or a radio button ! ") ;
		}
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsChecked(sId)
{
	var oField = fwkGetField(sId) ; 
	if ( oField != null )
	{
		if ( oField.tagName == 'INPUT' && ( oField.type == "checkbox" || oField.type == "radio" ) ) 
		{
			return oField.checked ;
		}
		else
		{
			alert( "ERROR : " + sId + " is not a checkbox or a radio button ! ") ;
		}
	}
	else
	{
		return null  ;
	}
}
//----------------------------------------------------------------------------------------------------
function fwkGetValue(arg)
{
	var oField = null ; 
	if ( typeof arg == "string" )
	{
		//alert ( "C'est une chaine ! \n typeof = " + typeof arg ) ;
		oField = fwkGetField(arg) ; 
	}
	else if ( typeof arg == "object" )
	{
		//alert ( "C'est un objet ! \n typeof = " + typeof arg ) ;
		oField = arg ; 
	}
	else
	{
		alert ( "ERROR : fwkGetValue() invalid argument type ! ( type = " + typeof arg + " )" ) ;
		return null ;
	}
	if ( oField != null )
	{
	/**
		if ( "checked" in oField )
		{
			alert ( "checked attribute found " );
			return ( oField.checked ? "1" : "0" );
		}
		**/
		if ( oField.type == "checkbox" )
		{
			alert ( "checkbox object" );
			return ( oField.checked ? "1" : "0" );
		}
		return oField.value ;
	}
	else
	{
		alert ( "ERROR : Field " + arg + " not found !") ;
		return null  ;
	}
}
//----------------------------------------------------------------------------------------------------
function fwkSetValue(sId,sValue)
{
	var oField = fwkGetField(sId) ; 
	if ( oField != null )
	{
		oField.value = sValue ;
	}
}
//----------------------------------------------------------------------------------------------------
function fwkGetName(sId)
{
	var oField = fwkGetField(sId) ; 
	if ( oField != null )
	{
		return oField.name ;
	}
}
//----------------------------------------------------------------------------------------------------
function fwkGetType(sId)
{
	var oField = fwkGetField(sId) ; 
	if ( oField != null )
	{
		return oField.type ;
	}
}
//----------------------------------------------------------------------------------------------------
// ENABLE / DISABLE 
//----------------------------------------------------------------------------------------------------
function fwkSetFieldButtonDisabled(sId, bDisabled)
{
	var oButton = document.getElementById(sId+"_button");
	if ( oButton != null )
	{
		//alert ( "tagName = " + oButton.tagName + " type = " + oButton.type );
		if ( oButton.tagName == "INPUT" && oButton.type == "button" ) 
		{
			oButton.disabled = bDisabled ;
		}
		else if ( oButton.tagName == "BUTTON" ) 
		{
			oButton.disabled = bDisabled ;
		}
		else if ( oButton.tagName == "IMG" ) 
		{
			if ( bDisabled )
			{
				oButton.style.visibility = "hidden" ;
			}
			else
			{
				oButton.style.visibility = "visible" ;
			}
		}
	}		
}
//----------------------------------------------------------------------------------------------------
function fwkEnable(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		oField.disabled = false ;
		fwkSetFieldButtonDisabled(sId, false);
	}
}
//----------------------------------------------------------------------------------------------------
function fwkDisable(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		oField.disabled = true ;
		fwkSetFieldButtonDisabled(sId, true);
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsEnabled(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		if ( oField.disabled != true ) return true ;
	}
	return false ;
}
//----------------------------------------------------------------------------------------------------
// VISIBILITY 
//----------------------------------------------------------------------------------------------------
function fwkSetFieldButtonVisibility(sId, sVisibility)
{
	var oButton = document.getElementById(sId+"_button");
	if ( oButton != null )
	{
		//alert ( "tagName = " + oButton.tagName + " type = " + oButton.type );
		if ( oButton.tagName == "INPUT" && oButton.type == "button" ) 
		{
			oButton.style.visibility = sVisibility ;
		}
		else if ( oButton.tagName == "BUTTON" ) 
		{
			oButton.style.visibility = sVisibility ;
		}
		else if ( oButton.tagName == "IMG" ) 
		{
			oButton.style.visibility = sVisibility ;
		}
	}		
}
//----------------------------------------------------------------------------------------------------
function fwkSetVisible(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		oField.style.visibility = "visible" ;
		fwkSetFieldButtonVisibility(sId, "visible");
	}
	return false ;
}
//----------------------------------------------------------------------------------------------------
function fwkSetHidden(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		oField.style.visibility = "hidden" ;
		fwkSetFieldButtonVisibility(sId, "hidden");
	}
}
//----------------------------------------------------------------------------------------------------
function fwkIsVisible(sId)
{
	var oField = fwkGetField(sId) ;
	if ( oField != null )
	{
		if ( oField.style.visibility == "visible" ) return true ;
	}
	return false ;
}

//----------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------
function RadioGroupGetValue(sName)
{
	var radioButtons = document.getElementsByName(sName) ; 
	if ( radioButtons != null )
	{
		for ( var i=0 ; i < radioButtons.length ; i++ )
		{
			if ( radioButtons[i].type == "radio" )
			{
				// alert ( "Id : " + radioButtons[i].id + " => VALUE = " + radioButtons[i].value )  ;
				if ( radioButtons[i].checked ) return radioButtons[i].value ;
			}
		}
		// Aucun bouton slectionn 
		return null ;
	}
	else
	{
		alert("Cannot found Radio Buttons Group for name "+sName ) ;
	}
}
//----------------------------------------------------------------------------------------------------
function RadioGroupSetValue(sName, sValue)
{
	var radioButtons = document.getElementsByName(sName) ; 
	if ( radioButtons != null )
	{
		for ( var i=0 ; i < radioButtons.length ; i++ )
		{
			if ( radioButtons[i].type == "radio" )
			{
				// alert ( "Id : " + radioButtons[i].id + " => VALUE = " + radioButtons[i].value )  ;
				//if ( radioButtons[i].checked ) return radioButtons[i].value ;
				if ( radioButtons[i].value == sValue ) 
				{
					radioButtons[i].checked = true  ;
				}
				else
				{
					radioButtons[i].checked = false  ;
				}
			}
		}
	}
	else
	{
		alert("Cannot found Radio Buttons Group for name "+sName ) ;
	}
}
//----------------------------------------------------------------------------------------------------
function showSelectedValue(sName)
{
	alert ( "Radio Group "+ sName + " : \nSELECTED VALUE = " + RadioGroupGetValue(sName) );
}
//----------------------------------------------------------------------------------------------------
