//------------------------------------------------------------------------------
// fwkFields.js : Gestion des champs de saisie (filtrage, validit & formatage)
//------------------------------------------------------------------------------
// Version : 2.0  ( 07/06/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

//==============================================================================
//          G E S T I O N   D E   L ' E T A T   D E S   C H A M P S  
//==============================================================================
//------------------------------------------------------------------------
var VG_fwkShallowCheckingErrorColor   = "white"  ; // Default error color
var VG_fwkShallowCheckingErrorBgColor = "#cc0000"; // Default error background color
var VG_fwkInvalidCharErrorColor       = "red"; 
//var VG_fwkDefaultStandardColor   = "blue";
//var VG_fwkDefaultStandardBgColor = "orange";
var VG_fwkFieldOnError = null ; // Variable Globale pour le timer
function fwkInvalidChar(oField)  
{
    VG_fwkFieldOnError = oField ;
    if ( oField.style.backgroundColor != VG_fwkInvalidCharErrorColor ) // Pour viter les pb de frappe clavier trs rapide
    {
	    var sInitialBgColor = oField.style.backgroundColor ;
	    //alert("initial BG-Color =" + sInitialBgColor );
		//VG_fwkFieldOnError.style.backgroundColor='red' ;	
		VG_fwkFieldOnError.style.backgroundColor=VG_fwkInvalidCharErrorColor ;
	    //window.setTimeout("VG_fwkFieldOnError.style.backgroundColor='white';", 50);
	    window.setTimeout("VG_fwkFieldOnError.style.backgroundColor='" + sInitialBgColor + "';", 50);
    }
}
/***
//------------------------------------------------------------------------
// Neutralisation de la couleur et des tats "erreur" d'un champ ( Reset )
//------------------------------------------------------------------------
function fwkResetFieldErrorStatus(oField)  //--- (Ver 1.2)
{
	oField.style.backgroundColor='white' ;
	oField.style.color= "#000066";
	oField.fwkErrorFlag = false ;
	oField.fwkShallowCheckingErrorFlag = false ;
}
***/
/***
//------------------------------------------------------------------------
// Marquage du champ pour une erreur fonctionnelle ( Foreign Key, etc... )
//------------------------------------------------------------------------
function fwkSetFieldErrorColor(oField)  //--- Champ en erreur
{
	oField.style.backgroundColor='red' ;
	oField.style.color='white';	
	oField.fwkErrorFlag = true ; // (Ver 1.2)
}
function fwkSetFieldStandardColor(oField)  //--- Champ OK ( couleur normale )
{
	//alert(oField.id + "fwkErrorFlag = "+ oField.fwkErrorFlag);
	oField.style.backgroundColor='white' ;
	oField.style.color= "#000066";
	oField.fwkErrorFlag = false ; // (Ver 1.2)
}
function fwkIsFieldOnError(oField)  //--- Le champ est-il en erreur (ETAT) (Ver 1.2)
{
	if ( oField == null ) return false ;
	if ( oField.fwkErrorFlag == null ) return false ;
	return oField.fwkErrorFlag ; 
}
***/
//------------------------------------------------------------------------
// Marquage du champ pour une erreur "superficielle" : controle de surface (format, .. )
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkDefineShallowCheckingErrorColors(sColor,sBgColor)
{
	VG_fwkShallowCheckingErrorColor   = sColor
	VG_fwkShallowCheckingErrorBgColor = sBgColor
}
//------------------------------------------------------------------------
function fwkSetFieldShallowCheckingErrorColor(oField) 
{
	oField.fwkShallowCheckingErrorFlag = true ;
	if ( ! oField.fwkInitialColor )
	{
		if ( oField.style.color )
		{
			//alert(  "fwkInitialColor NOT SET : storing style.color " + oField.style.color  );
			oField.fwkInitialColor = oField.style.color ;
		}
		else
		{
			//alert(  "fwkInitialColor NOT SET : no style.color => storing '?' "  );
			oField.fwkInitialColor = "?" ;
		}
	}
	if ( ! oField.fwkInitialBgColor )
	{
		if ( oField.style.backgroundColor )
		{
			oField.fwkInitialBgColor = oField.style.backgroundColor ;
		}
		else
		{
			oField.fwkInitialBgColor = "?" ;
		}
	}
	//--- Set the error colors 
	oField.style.color           = VG_fwkShallowCheckingErrorColor;	
	oField.style.backgroundColor = VG_fwkShallowCheckingErrorBgColor ;
}
//------------------------------------------------------------------------
//function fwkSetFieldShallowCheckingStandardColor(oField)
function fwkRestoreInitialColors(oField)
{
	if ( oField == null ) return ;
	if ( oField.fwkShallowCheckingErrorFlag == null ) return ;
	if ( oField.fwkShallowCheckingErrorFlag == false ) return ;
	
	oField.fwkShallowCheckingErrorFlag = false ;	
	if ( ! oField.fwkInitialColor )
	{
		oField.style.color = "" ;
	}
	else
	{
		if ( oField.fwkInitialColor == "?" )
		{
			//oField.style.color = null ; // OK on FireFox ( not OK on IE )
			oField.style.color = "" ; // OK on FireFox and IE
		}
		else
		{
			oField.style.color = oField.fwkInitialColor ;
		}
	}
	if ( ! oField.fwkInitialBgColor )
	{
		oField.style.backgroundColor = "" ;
	}
	else
	{
		if ( oField.fwkInitialBgColor == "?" )
		{
			//oField.style.backgroundColor = null ; // OK on FireFox ( not OK on IE )
			oField.style.backgroundColor = "" ; // OK on FireFox and IE
		}
		else
		{
			oField.style.backgroundColor = oField.fwkInitialBgColor ;
		}
	}
}
//------------------------------------------------------------------------
/***
function fwkIsFieldOnShallowCheckingError(oField) 
{
	if ( oField == null ) return false ;
	if ( oField.fwkShallowCheckingErrorFlag == null ) return false ;
	return oField.fwkShallowCheckingErrorFlag ; 
}
***/
//------------------------------------------------------------------------
function fwkGetOptionalChars(sType)  
{
	if ( sType == null ) return "" ;
	var i = sType.indexOf(":") ;
	if ( i >= 0 ) 
	{
		return sType.substr(i+1) ;
	}
	return "";
}
//------------------------------------------------------------------------
function fwkGetPureType(sType)
{
	if ( sType == null ) return "" ;
	var i = sType.indexOf(":") ;
	if ( i >= 0 ) 
	{
		return sType.substr(0, i) ;
	}
	return sType;	
}
//==============================================================================
//                     KEY CODE (CHARACTER) INPUT FILTER 
//------------------------------------------------------------------------------
// Use this function in the "onKeyPress" event to call this function for 
// each key press by the user
//==============================================================================
function fwkFilter(oEvent, oField, sType)  
{
	if ( oEvent == null )
	{
		alert ( "ERROR on fwkFilter() : No event parameter !" );
		return ;
	}
	if ( oField == null )
	{
		alert ( "ERROR on fwkFilter() : No field parameter !" );
		return ;
	}
	
	if ( sType == null ) return ;
	//fwkSetFieldShallowCheckingStandardColor(oField);

	var sOptionalChars = fwkGetOptionalChars(sType);
	var sPureType      = fwkGetPureType(sType);
	var sPureTypeUC    = sPureType.toUpperCase() ;
	
	if      ( sPureTypeUC == "INT"        ) return fwkIntFilter     (oEvent, oField, sOptionalChars) ;
	else if ( sPureTypeUC == "NUM"        ) return fwkNumFilter     (oEvent, oField, sOptionalChars) ;
	else if ( sPureTypeUC == "ALPHANUMUC" ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "ALPHANUMLC" ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "ALPHANUM"   ) return fwkAlphaNumFilter(oEvent, oField, sOptionalChars, ""  ) ;
	else if ( sPureTypeUC == "ALPHAUC"    ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "ALPHALC"    ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "ALPHA"      ) return fwkAlphaFilter   (oEvent, oField, sOptionalChars, ""  ) ;
	else if ( sPureTypeUC == "DATE"       ) return fwkDateFilter    (oEvent, oField) ;
	else if ( sPureTypeUC == "SELECTUC"   ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, "U" ) ;
	else if ( sPureTypeUC == "SELECTLC"   ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, "L" ) ;
	else if ( sPureTypeUC == "SELECT"     ) return fwkSelectFilter  (oEvent, oField, sOptionalChars, ""  ) ;
}
//------------------------------------------------------------------------
function fwkGetKeyCode(oEvent)  
{
	if ( window.event )
	{
		//--- Internet Explorer
		window.status = "I.E. : event.keyCode = " + oEvent.keyCode + " / window.event.keyCode = " + window.event.keyCode  ;
		return window.event.keyCode ;
	}
	else
	{
		//--- Mozilla / Firefox
		if ( oEvent.keyCode ) // Ctrl Key ( Backspace, Home, Arrows, ... ) 
		{
			//window.status = "Mozilla/Firefox : keyCode = " + oEvent.keyCode ;
			return 0 ;
		}
		else if ( oEvent.which ) // Character 
		{
			//window.status = "Mozilla/Firefox : which = " + oEvent.which + " / charCode = " + oEvent.charCode ;
			return oEvent.which ;
		}
		return 0;
	}
}
//------------------------------------------------------------------------
function fwkSetKeyCode(oEvent, iNewKeyCode )  
{
	if ( window.event ) //--- Internet Explorer
	{
		window.status = "I.E. : initial keyCode = " + window.event.keyCode  + " / new keyCode = " + iNewKeyCode  ;
		window.event.keyCode = iNewKeyCode ;
	}
	else if ( oEvent.initKeyEvent ) //--- Mozilla / Firefox
	{
		oEvent.initKeyEvent('keypress', true, true, window, false, false, false, false, 0, iNewKeyCode );
	}
}
//------------------------------------------------------------------------
// Fonction de filtrage des caractres saisis pour un champ ENTIER
//------------------------------------------------------------------------
function fwkIntFilter(oEvent, oField, sOpt) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	if ( iCar >= 48 && iCar <= 57 ) // Chiffres ( 0  9 )
	{
		return true ; // OK
	}
	else 
	{
		if ( sOpt != null )
		{
			// S'agit-il d'un caractre optionnel ?
			var sAuthorized = "+-" ; // Les seuls caractres optionnels autoriss 
			var sCar = String.fromCharCode(iCar) ;
			if ( ( sAuthorized.indexOf(sCar) >= 0 ) && ( sOpt.indexOf(sCar) >= 0 ) )
			{
				return true ;
				// Vrification qu'un de ces caractres n'a pas dj t saisi 
				/*  Problmatique si le champ est "selected" et que le car  dj t saisi
				if (  ( window.event.srcElement.value.indexOf("-") < 0 )
				   && ( window.event.srcElement.value.indexOf("+") < 0 ) )
				{
					return true ;
				}
				*/
			}
		}
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ NUMERIQUE
//------------------------------------------------------------------------
function fwkNumFilter(oEvent, oField, sOpt) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	if ( ( iCar >= 48 && iCar <= 57 ) || ( iCar == 46 ) ) // Chiffres ( 0  9 ) plus le POINT 
	{
		return true ;
	}
	else 
	{
		// S'agit-il d'un caractre optionnel ?
		var sAuthorized = "+-" ; // Les seuls caractres optionnels autoriss 
		var sCar = String.fromCharCode(iCar) ;
		if ( ( sAuthorized.indexOf(sCar) >= 0 ) && ( sOpt.indexOf(sCar) >= 0 ) )
		{
			return true ;
		}
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// 
//------------------------------------------------------------------------
function privateAlphaFilter(iCar, sOpt, sUpperLower ) 
{
	//--- Lettres majuscules ( A-Z )
	if ( iCar >=  65 && iCar <=  90 ) 
	{
		if ( sUpperLower == "L" ) // Lower Case  
		{
			return iCar + 32;  // Convert
		}
		return iCar ;
	}
	//--- Lettres minuscules ( a-z )
	if ( iCar >=  97 && iCar <= 122 ) 
	{
		if ( sUpperLower == "U" ) // Upper Case 
		{
			return iCar - 32;  // Convert
		}
		return iCar ;
	}
	//--- Lettres accentues (          etc... )
	if ( iCar >= 194 )
	{
		return iCar ;
	}
	//--- Caractre optionnel ?
	var sCar = String.fromCharCode(iCar) ;
	if ( sOpt.indexOf(sCar) >= 0 )
	{
		return iCar ;
	}
	//--- Dans tous les autres cas : Caractre refus 	
	return 0 ;
}

//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ ALPHABETIQUE PUR
//------------------------------------------------------------------------
function fwkAlphaFilter(oEvent, oField, sOpt, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	
	var iFilteredChar = privateAlphaFilter(iCar, sOpt, sUpperLower ) ;
	if ( iFilteredChar != 0 ) // Char OK
	{
		if ( iFilteredChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iFilteredChar )  
		} 
		return true ;
	}
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ ALPHANUMERIQUE
//------------------------------------------------------------------------
function fwkAlphaNumFilter(oEvent, oField, sOpt, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 
	
	//--- Chiffres ( 0  9 )
	if ( iCar >= 48 && iCar <= 57 ) // Chiffres ( 0  9 )
	{
		return true ;
	}

	var iFilteredChar = privateAlphaFilter(iCar, sOpt, sUpperLower ) ;
	if ( iFilteredChar != 0 ) // Char OK
	{
		if ( iFilteredChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iFilteredChar )  
		}
		return true ;
	}
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ DATE
//------------------------------------------------------------------------
function fwkDateFilter(oEvent, oField) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	if ( iCar < 31 ) return true ; 

	if ( iCar >= 47 && iCar <= 57 ) // "/" ou chiffre ( 0  9 ) 
	{
		return true ;
	}
	//--- Dans tous les autres cas : Caractre refus 	
	fwkInvalidChar(oField);
	return false ;
}
//------------------------------------------------------------------------
// Fonctions de filtrage des caractres saisis pour un champ SELECT
//------------------------------------------------------------------------
function fwkSelectFilter(oEvent, oField, sSelectedChars, sUpperLower ) 
{
	var iCar = fwkGetKeyCode(oEvent) ; // Caractre saisi
	var iNewChar = iCar ;
	if ( iCar < 31 ) return true ; 

	//--- Conversion ventuelle en majuscules ou minuscules
	if ( ( iCar >=  65 && iCar <=  90 ) && ( sUpperLower == "L" ) ) 
	{
		iNewChar = iCar + 32;  // Convert to Lower Case 
	}
	else if ( ( iCar >=  97 && iCar <= 122 ) && ( sUpperLower == "U" ) )
	{
		iNewChar = iCar - 32;  // Convert to Upper Case
	}
	//--- Le caractre fait-il partie de la liste des caractres acceptables ?
	var sNewChar = String.fromCharCode(iNewChar) ;
	if ( sSelectedChars.indexOf(sNewChar) >= 0 )
	{
		if ( iNewChar != iCar ) 
		{
			//--- Re-Set the Character (can be converted)
			fwkSetKeyCode(oEvent, iNewChar )  
		}	
		return true ;
	}
	//--- Dans tous les autres cas : Caractre refus
	fwkInvalidChar(oField);
	return false ;
}

//==============================================================================
//    C O N T R O L E    D E    V A L I D I T E    E T    F O R M A T A G E
//==============================================================================
//------------------------------------------------------------------------
// Check the field is not null
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckNotNull(oField )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckNotNull() : No field parameter !" );
		return ;
	}
	if ( oField.value == null || oField.value == "" )
	{
		//--- This field is null => error
		fwkSetFieldShallowCheckingErrorColor(oField); 
	}
	else
	{
		//--- This field is not null => OK
		//if ( fwkIsFieldOnShallowCheckingError(oField) )
		//{
		//	fwkSetFieldShallowCheckingStandardColor(oField); 
		//}
		fwkRestoreInitialColors(oField);
	}
}
//------------------------------------------------------------------------
// Check the field match the regular expression
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckRegExp(oField, bCanBeNull, sRegExp )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckRegExp() : No field parameter !" );
		return ;
	}
	var sFieldValue = oField.value ;
	if ( sFieldValue == null || sFieldValue == "" )
	{
		if ( bCanBeNull == false ) // NOT NULL
		{
			//--- The field is null and it's not authorized => ERROR
			fwkSetFieldShallowCheckingErrorColor(oField); 
		}
		else
		{
			//--- The field is null, but it's authorized => OK
			//if ( fwkIsFieldOnShallowCheckingError(oField) )
			//{
			//	fwkSetFieldShallowCheckingStandardColor(oField);
			//}
			fwkRestoreInitialColors(oField);
		}
		return ;
	}
	else
	{
		var re = new RegExp( sRegExp );
		if ( ! sFieldValue.match(re) )
		{
			//--- The field doesn't match the Reg Exp => ERROR
			fwkSetFieldShallowCheckingErrorColor(oField); 
		}
		else
		{
			//--- The field match the Reg Exp  => OK
			//if ( fwkIsFieldOnShallowCheckingError(oField) )
			//{
			//	fwkSetFieldShallowCheckingStandardColor(oField);
			//}
			fwkRestoreInitialColors(oField);
		}	
	}
}
//------------------------------------------------------------------------
// Fonction de controle de validit et de formatage du champ selon son type
// ( associe  l'vnement "onBlur" )
//------------------------------------------------------------------------
function fwkCheckField(oField, bCanBeNull, sType, MinValue, MaxValue, sFormat )  
{
	if ( oField == null )
	{
		alert ( "ERROR on fwkCheckField() : No field parameter !" );
		return ;
	}
	if ( sType == null )
	{
		alert ( "ERROR on fwkCheckField() : No type parameter !" );
		return ;
	}

	var sPureType = fwkGetPureType(sType);
	var sPureTypeUC = sPureType.toUpperCase() ;
	//alert( "fwkCheckField() : Type = "+ sType + " => Pure Type = " + sPureType + " => Pure Type UC = " + sPureTypeUC) ;

/***
	//--- Si le champs est dans un tat "erreur fonctionnelle" ( ForeignKey, etc ... )
	if ( fwkIsFieldOnError(oField) )
	{
		// pour traiter le cas d'une re-saisie  l'identique qui ne provoque pas de "OnChange" 
		fwkSetFieldErrorColor(oField); //--- R-affectation de la couleur correspondant  son tat
		
		// Mise en commentaire YMO: Ne prends pas encompte le reformatage de la nouvelle valeur
		// si celle ci est correcte
		//return ; // Inutile d'aller plus loin
	}
***/
	var bRet = true ;
	var sFieldValue = oField.value ;
	//--- Controle de champ null 
	if ( sFieldValue == null || sFieldValue == "" )
	{
		if ( bCanBeNull == false ) // NOT NULL
		{
			bRet = false ;
		}
	}
	else // Champ pas null
	{
		var sOptionalChars = fwkGetOptionalChars(sType);
		//--- Controles de validit du champ  
		if      ( sPureTypeUC == "INT"        ) bRet = fwkCheckInt      (sFieldValue, MinValue, MaxValue) ;
		else if ( sPureTypeUC == "NUM"        ) bRet = fwkCheckNum      (sFieldValue, MinValue, MaxValue) ;
		else if ( sPureTypeUC == "DATE"       ) bRet = fwkCheckDate     (sFieldValue) ;
		else if ( sPureTypeUC == "ALPHA"      ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, ""  ) ;
		else if ( sPureTypeUC == "ALPHAUC"    ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, "U" ) ;
		else if ( sPureTypeUC == "ALPHALC"    ) bRet = fwkCheckAlpha    (sFieldValue, sOptionalChars, "L" ) ;
		else if ( sPureTypeUC == "ALPHANUM"   ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, ""  ) ;
		else if ( sPureTypeUC == "ALPHANUMUC" ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, "U" ) ;
		else if ( sPureTypeUC == "ALPHANUMLC" ) bRet = fwkCheckAlphaNum (sFieldValue, sOptionalChars, "L" ) ;
		else if ( sPureTypeUC == "SELECT"     ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
		else if ( sPureTypeUC == "SELECTUC"   ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
		else if ( sPureTypeUC == "SELECTLC"   ) bRet = fwkCheckSelect   (sFieldValue, sOptionalChars ) ;
	}
	if ( bRet == false ) //--- Valeur incorrecte  	
	{
		fwkSetFieldShallowCheckingErrorColor(oField); 
	}
	else //--- Valeur correcte  
	{
		//--- Champ de couleur normale 
		//if ( fwkIsFieldOnShallowCheckingError(oField) )
		//{
		//	fwkSetFieldShallowCheckingStandardColor(oField);
		//}
		fwkRestoreInitialColors(oField);

		//--- Formatage 
		if ( sFieldValue != null && sFieldValue != "" )
		{
			if      ( sPureTypeUC == "INT"      ) oField.value = fwkFormatInt (sFieldValue, sFormat) ;
			else if ( sPureTypeUC == "NUM"      ) oField.value = fwkFormatNum (sFieldValue, sFormat) ;
			else if ( sPureTypeUC == "DATE"     ) oField.value = fwkFormatDate(sFieldValue, sFormat) ;
		}
	}
}

//------------------------------------------------------------------------
// Controle de cohrence des lments Jour, Mois et Anne d'une date 
//------------------------------------------------------------------------
function fwkValidDate(sJour, sMois, sAnnee) // return type : Boolean
{
	// alert("fwkValidDate('"+sJour+"', '"+sMois+"', '"+sAnnee+"') " ) ;
	try 
	{
		var nbJours = new Array(0,31,28,31,30,31,30,31,31,30,31,30,31);
		var j = parseInt(sJour,10) ;
		var m = parseInt(sMois,10) ;
		var a = parseInt(sAnnee,10) ;
		//--- Si Anne bissextile
		if ( ( a%4 == 0 && a%100 != 0 ) || a%400 == 0 )  nbJours[2] = 29  ; // 29 jours en Fvrier
		
		//alert("fwkValidDate("+j+","+m+","+a+") nbJours[2] = " + nbJours[2] + "  nbJours[m] = " + nbJours[m] ) ;
		//window.status = "fwkValidDate("+j+","+m+","+a+") nbJours[2] = " + nbJours[2] + "  nbJours[m] = " + nbJours[m] ;
	
		//--- Validite de l'Annee
		if ( ( a < 0 ) || ( a > 9999 ) )  return false ;
		//--- Validite du Mois
		if ( ( m < 1 ) || ( m > 12 ) )  return false ;
		//--- Validite du Jour 
		if ( ( j < 1 ) || ( j > nbJours[m] ) )  return false ;
		//--- OK : Date valide  
		return true ;
	}
	catch (e) 
	{
		window.status = "fwkValidDate : Exception"  ;
		return false ;
	}
}
//------------------------------------------------------------------------
// Controle de validit d'un champ de type DATE 
//------------------------------------------------------------------------
//function fwkCheckDate(oField) // return type : Boolean
function fwkCheckDate(sFieldValue) // return type : Boolean
{
var i, c ;
var JJ, MM, AA ;

	if ( sFieldValue.length == 6 ) // "JJMMAA" (ne doit contenir que des chiffres)
	{
		//------------------------------------------------------
		// 6 caractres => format attendu : "JJMMAA"
		//------------------------------------------------------
		for ( i = 0 ; i < 6 ; i++ ) //--- Chiffre uniquement ( pas de  "/" )
		{
			c = sFieldValue.charCodeAt(i) ;
			if ( c < 48 || c > 57 ) return false ;
		}
        JJ   = sFieldValue.substr(0,2);
        MM   = sFieldValue.substr(2,2);
        AA   = sFieldValue.substr(4,2);
		return fwkValidDate(JJ, MM, AA) ;
	}
	else if ( sFieldValue.length == 8 ) // "JJ/MM/AA" ou "JJMMAAAA" 
	{
		if ( sFieldValue.indexOf("/") >= 0 ) // Si il y a au moins un "/"
		{
			//------------------------------------------------------
			// 8 caractres avec "/" => format attendu : "JJ/MM/AA"
			//------------------------------------------------------
			for ( i = 0 ; i < 8 ; i++ ) //--- Chiffre + "/" (code 47) en position 2 et 5
			{
				c = sFieldValue.charCodeAt(i) ;
				if (      ( c < 47 || c > 57 )  
				      ||  ( ( c == 47 ) && ( ( i != 2 ) && ( i != 5 ) )  )    
				      ||  ( ( c != 47 ) && ( ( i == 2 ) || ( i == 5 ) )  )
				   )
				{
					return false ;
				}
			}
			JJ   = sFieldValue.substr(0,2);
	        MM   = sFieldValue.substr(3,2);
	        AA   = sFieldValue.substr(6,2);
			return fwkValidDate(JJ, MM, AA) ;
		}
		else
		{
			//------------------------------------------------------
			// 8 caractres sans "/" => format attendu : "JJMMAAAA"
			//------------------------------------------------------
			for ( i = 0 ; i < 8 ; i++ ) //--- Chiffre uniquement ( pas de  "/" )
			{
				c = sFieldValue.charCodeAt(i) ;
				if ( c < 48 || c > 57 ) return false ;
			}
	        JJ   = sFieldValue.substr(0,2);
	        MM   = sFieldValue.substr(2,2);
	        AA   = sFieldValue.substr(4,4);
			return fwkValidDate(JJ, MM, AA) ;
		}
	}
	else if ( sFieldValue.length == 10 ) // "JJ/MM/AAAA"
	{
		//------------------------------------------------------
		// 10 caractres => format attendu : "JJ/MM/AAAA"
		//------------------------------------------------------
		for ( i = 0 ; i < 10 ; i++ )//--- Chiffre + "/" (code 47) en position 2 et 5
		{
			c = sFieldValue.charCodeAt(i) ;
			if (      ( c < 47 || c > 57 )  
			      ||  ( ( c == 47 ) && ( ( i != 2 ) && ( i != 5 ) )  )    
			      ||  ( ( c != 47 ) && ( ( i == 2 ) || ( i == 5 ) )  )
			   )
			{
				return false ;
			}
		}
        JJ   = sFieldValue.substr(0,2);
        MM   = sFieldValue.substr(3,2);
        AA   = sFieldValue.substr(6,4);
		return fwkValidDate(JJ, MM, AA) ;
	}
	else if ( sFieldValue.length != 0 )
	{
		return false ;
	}
	return true ; // Date OK
}

//------------------------------------------------------------------------
// Controle de validit d'un champ de type ENTIER 
//------------------------------------------------------------------------
//function fwkCheckInt(oField) // return type : Boolean
function fwkCheckInt(sFieldValue, iMinValue, iMaxValue) // return type : Boolean
{      
	var re = new RegExp("^[-+]?[0-9]*$");
	if ( ! sFieldValue.match(re) )
	{
		return false ;
	}
/*
	//--- Si le signe n'est pas au dbut ( position ZERO ) => erreur
	if ( sFieldValue.lastIndexOf("-") > 0 ) return false ;
	if ( sFieldValue.lastIndexOf("+") > 0 ) return false ;
*/
	
	var iFieldValue = parseInt(sFieldValue,10) ;
	// NB: parseInt ne controle pas la validit ( "2 2" -> 2, "2a" -> 2, etc...)
	// et ne lve pas d'exception (renvoie NaN si aucun parsing possible)

	//--- Si le nombre n'est pas dans la fourchette autorise
	if ( iMinValue != null && iFieldValue < iMinValue ) return false;
	if ( iMaxValue != null && iFieldValue > iMaxValue ) return false;

	//--- Dans tous les autres cas, Champ OK
	return true ;
}


//------------------------------------------------------------------------
// Controle de validit d'un champ de type NUMERIQUE 
//------------------------------------------------------------------------
//function fwkCheckNum(oField) // return Boolean
function fwkCheckNum(sFieldValue, fMinValue, fMaxValue) // return Boolean
{      
	var re = new RegExp("^[-+]?[0-9\.]*$");
	if ( ! sFieldValue.match(re) )
	{
		return false ;
	}
/**
	//--- Si le signe n'est pas au dbut ( position ZERO ) 
	// ( et s'il y en a plusieurs, ils ne peuvent pas tre tous  la position 0 )
	if ( sFieldValue.lastIndexOf("-") > 0 ) return false ;
	if ( sFieldValue.lastIndexOf("+") > 0 ) return false ;
**/

	//--- Si il y a plus d'une marque dcimale ( . )
	var i  = 0;
	var nb = 0;
	for ( i = 0 ; i < sFieldValue.length ; i++ )
	{
		if ( sFieldValue.charAt(i) == '.' ) nb ++;
	}
	if ( nb > 1 ) return false ;

	//--- Si le nombre n'est pas dans la fourchette autorise
	if ( fMinValue != null && parseFloat(sFieldValue) < fMinValue ) return false;
	if ( fMaxValue != null && parseFloat(sFieldValue) > fMaxValue ) return false;

	//--- Dans tous les autres cas, Champ OK
	return true ;
}

//------------------------------------------------------------------------
function fwkCheckCharAlpha (c, sOpt, sUpperLower ) // return Boolean
{
	if ( c >=  65 && c <=  90 ) //--- Lettres majuscules ( A-Z )
	{
		if ( sUpperLower == "L" ) // Lower Case  
		{
			return false ; 
		}
		return true ; // OK
	}
	else if ( c >=  97 && c <= 122 ) //--- Lettres minuscules ( a-z )
	{
		if ( sUpperLower == "U" ) // Upper Case 
		{
			return false;
		}
		return true ; // OK
	}
	else if ( c >= 194 ) //--- Lettres accentues (          etc... )
	{
		return true ; // OK
	}
	else //--- Caractre optionnel ?
	{
		if ( sOpt.indexOf(String.fromCharCode(c)) < 0 )
		{
			return false ;
		}
	}
	//--- OK le caractre est acceptable
	return true ;
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkCheckAlpha (sFieldValue, sOpt, sUpperLower ) // return Boolean
{
	//window.status = "fwkCheckAlpha("+sFieldValue+","+sOpt+","+sUpperLower+")" ;
	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
		c = sFieldValue.charCodeAt(i) ;
		if ( fwkCheckCharAlpha (c, sOpt, sUpperLower ) == false ) 
		{
			return false ;
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------
function fwkCheckAlphaNum (sFieldValue, sOpt, sUpperLower ) // return Boolean
{
	//window.status = "fwkCheckAlphaNum("+sFieldValue+","+sOpt+","+sUpperLower+")" ;
	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
		c = sFieldValue.charCodeAt(i) ;
		//--- Chiffres ( 0  9 )
		if ( c >= 48 && c <= 57 ) // Chiffres ( 0  9 )
		{
			continue; // OK
		}
		else
		{
			if ( fwkCheckCharAlpha (c, sOpt, sUpperLower ) == false ) 
			{
				return false ;
			}
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}
//------------------------------------------------------------------------
function fwkCheckSelect (sFieldValue, sOpt ) // return Boolean
{
	window.status = "fwkCheckSelect"+sFieldValue+","+sOpt+")" ;
//	var c = 0 ;
	for ( var i = 0 ; i < sFieldValue.length ; i++ )
	{
//		c = sFieldValue.charCodeAt(i) ;		
//		if ( sOpt.indexOf(String.fromCharCode(c)) < 0 )
		if ( sOpt.indexOf(sFieldValue.charAt(i)) < 0 )
		{
			return false ;
		}
	}
	//--- OK (tous les caractres sont acceptables)
	return true ;
}

//==============================================================================
//    FORMAT FUNCTIONS 
//==============================================================================
//------------------------------------------------------------------------
// Formatage d'un champ de type DATE
//------------------------------------------------------------------------
function fwkFormatDateYMD( sYear, sMonth, sDay, sFormat) // return type : String ( Formated Value )
{
	var sFormatUC = "DD/MM/YYYY" ; // Default Format = French format
	if ( sFormat != null )  sFormatUC = sFormat.toUpperCase();

	if ( sDay == null || sMonth == null || sYear == null )
	{
		alert("ERROR : fwkFormatDateDMY : Day or Month or Year is null ! " );
		return "";
	}
	/**
	if ( isNaN(sD) || isNaN(sM) || isNaN(sY) )
	{
		alert("ERROR : fwkFormatDateDMY : Day or Month or Year is not a number ! " );
		return "";
	}
	**/
	var sDD = null ;
	var sMM = null ;
	var sYY = null ;
	var sYYYY = null ;
	try {
		var iDay = parseInt(sDay,10) ;
		if ( iDay < 1 || iDay > 31 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid day " + iDay ) ;
			return "";
		}
		var iMonth = parseInt(sMonth,10) ;
		if ( iMonth < 1 || iMonth > 12 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid month " + iMonth ) ;
			return "";
		}
		var iYear = parseInt(sYear,10) ;
		if ( iYear < 0 || iYear > 9999 )
		{
			alert("ERROR : fwkFormatDateYMD : Invalid year " + iYear ) ;
			return "";
		}
	
		if ( iDay < 10 ) sDD = "0"+iDay; 
		else             sDD =  ""+iDay ;

		if ( iMonth < 10 ) sMM = "0"+iMonth;
		else               sMM =  ""+iMonth ;

		if ( iYear >= 1000 && iYear <= 9999 )
		{
			sYYYY = ""+iYear ;
		}
		else if ( iYear >= 100 && iYear <= 999 )
		{
			sYYYY = "2"+iYear ;
		}
		else if ( iYear >= 10 && iYear <= 99 )
		{
			sYYYY = "20"+iYear ;
		}
		else if ( iYear > 0 && iYear <= 9 )
		{
			sYYYY = "200"+iYear ;
		}
		sYY = sYYYY.substr(2,2);
		
		//TODO : Remplacer par substitution REGEXP
		if ( sFormatUC == "DD/MM/YYYY" ) return sDD+"/"+sMM+"/"+sYYYY ;
		if ( sFormatUC == "DD/MM/YY"   ) return sDD+"/"+sMM+"/"+sYY ;
		if ( sFormatUC == "MM/DD/YYYY" ) return sMM+"/"+sDD+"/"+sYYYY ;
		if ( sFormatUC == "MM/DD/YY"   ) return sMM+"/"+sDD+"/"+sYY ;
		if ( sFormatUC == "DD-MM-YYYY" ) return sDD+"-"+sMM+"-"+sYYYY ;
		if ( sFormatUC == "DD-MM-YY"   ) return sDD+"-"+sMM+"-"+sYY ;
		if ( sFormatUC == "MM-DD-YYYY" ) return sMM+"-"+sDD+"-"+sYYYY ;
		if ( sFormatUC == "MM-DD-YY"   ) return sMM+"-"+sDD+"-"+sYY ;
	} catch(ex) {
		alert("ERROR : fwkFormatDateYMD : Year = " + sYear + " Month = " + sMonth + " Day = " + sDay + " : Exception " + ex.message );		
	}
	
	
}
//------------------------------------------------------------------------
function fwkFormatDate(sVal, sFormat) // return type : String ( Formated Value )
{
var sDD, sMM, sYY, sYYYY ;

	//--- Si le champ est vide => pas de formatage
	if ( sVal == null ) return sVal ;
	if ( sVal.length == 0 ) return sVal ;
	
	var sFormatUC = "DD/MM/YYYY" ; // Default Format
	if ( sFormat != null )  sFormatUC = sFormat.toUpperCase();

	//--- Si il y a dj des sparateurs => pas de formatage
	if ( sVal.indexOf("/") >= 0 ) 
	{
		return sVal ;
	}
	else if ( sVal.length == 6 ) // "DDMMYY" 
	{
		sDD   = sVal.substr(0,2);
		sMM   = sVal.substr(2,2);
		sYY   = sVal.substr(4,2);
		sYYYY = "20"+sYY ;
	}  
	else if ( sVal.length == 8 ) // "DDMMYYYY"  
	{
		sDD   = sVal.substr(0,2);
		sMM   = sVal.substr(2,2);
		sYY   = sVal.substr(4,2);
		sYYYY = sVal.substr(4,4);
	}
	else
	{
		return sVal ;	
	}
	if ( sFormatUC == "DD/MM/YYYY" ) 
	{
		return sDD+"/"+sMM+"/"+sYYYY ;
	}
	else if ( sFormatUC == "DD/MM/YY" ) 
	{
		return sDD+"/"+sMM+"/"+sYY ;
	}
	/***
	else if ( sFormatUC == "DD-MM-YYYY" ) 
	{
		return sDD+"-"+sMM+"-"+sYYYY ;
	}
	else if ( sFormatUC == "DD-MM-YY" ) 
	{
		return sDD+"-"+sMM+"-"+sYY ;
	}
	else if ( sFormatUC == "MM-DD-YYYY" )  // American format
	{
		return sMM+"-"+sDD+"-"+sYYYY ;
	}
	else if ( sFormatUC == "MM-DD-YY" ) // American format
	{
		return sMM+"-"+sDD+"-"+sYY ;
	}
	else if ( sFormatUC == "YYYY-MM-DD" )  // ISO
	{
		return sYYYY+"-"+sMM+"-"+sDD ;
	}
	***/
	else // No Format
	{
		return sVal ;
	}
}

//------------------------------------------------------------------------
// Formatage d'un champ de type ENTIER
//------------------------------------------------------------------------
//function fwkFormatInt(oField, sFormat) // return type : Void
function fwkFormatInt(sVal, sFormat) // return type : String ( Formated Value )
{
	//--- Si le champ est vide => pas de formatage
	if ( sVal == null ) return sVal ;
	if ( sVal.length == 0 ) return sVal ;

	if ( sFormat == null )       return sVal ;
//	if ( oField.value.length == 0 ) return ; 	//--- Si le champ est vide => pas de formatage

//	var sVal         = oField.value ;   // Valeur originale du champ 
	var sSigne       = "" ;  // Signe de la valeur originale
	var sUnsignedVal = "" ;  // Valeur originale sans le signe
	var sNewVal      = "" ;  // Valeur formate 
	
	//--- Sparation du signe et de la valeur non signe  
	sSigne  = sVal.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
	if ( ( sSigne == "-" ) || ( sSigne == "+" ) )  
	{
		sUnsignedVal = sVal.substr(1) ;
	}
	else
	{
		sSigne = "+" ; // par dfaut 
		sUnsignedVal = sVal ;
	}
	//alert ( "sSigne = "+sSigne + " sUnsignedVal = "+sUnsignedVal ) ;	
	
	//--- Remplissage  gauche avec des ZEROS ?
	var sFiller   = null ;
	var iNbDigits = 0 ;
	if ( sFormat.indexOf("0") >= 0 ) sFiller = "0" ;
	if ( sFiller != null ) 
	{
		var i = 0
		//--- Nb de caractres attendus (dans le format)
		for ( i = 0 ; i < sFormat.length ; i++ )
		{
			if ( sFormat.charAt(i) == '0' ) iNbDigits++ ;
		}
		//--- Nb caractres de remplissage  ajouter
		var iDeltaSize = iNbDigits - sUnsignedVal.length ; 
		if ( iDeltaSize < 0 ) iDeltaSize = 0 ;
		//--- Composition de la chaine de caractres formate sans le signe
		sNewVal = "" ;
		for ( i = 0 ; i < iDeltaSize ; i++ )
		{
			sNewVal += sFiller;
		}
		sNewVal += sUnsignedVal ;
	}
	else
	{
		//--- Aucun formatage 
		sNewVal = sUnsignedVal ;
	}
	//alert ( "sNewVal avant mise en plce du signe = "+sNewVal ) ;	

	//--- Mise en place du signe (si ncessaire)
	if ( sFormat.indexOf("+") >= 0 ) // On veut toujours un signe ( + ou - )
	{
		sNewVal = sSigne + sNewVal ;
	}
	else if ( sFormat.indexOf("-") >= 0 ) // On veut un signe uniquement si ngatif ( - )
	{
		if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde le "-" 
	}
	else  // Aucune exigence au niveau du format 
	{
		if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde que le signe "-" 
	}

	//--- Affectation de la valeur formate dans le champ de saisie
	//oField.value = sNewVal ;      
	return sNewVal ;
}

//------------------------------------------------------------------------
// Formatage d'un champ de type NUMERIQUE
//------------------------------------------------------------------------
//function fwkFormatNum(oField, sFormat) // formatage 
function fwkFormatNum(sVal, sFormat) // // return type : String ( Formated Value ) 
{
	//--- Si le champ est vide => pas de formatage
	if ( sVal == null )     return sVal ;
	if ( sVal.length == 0 ) return sVal ;

	if ( sFormat == null )     return sVal ;
	if ( sFormat.length == 0 ) return sVal ;

	//var sVal               = oField.value ;			// Valeur originale du champ 
	var sSigne             = "" ;  					// Signe de la valeur originale
	var sUnsignedVal       = "" ;   				// Valeur originale sans le signe
	var sUnsignedValBefore = "" ;  					// Valeur originale sans le signe avant le point
	var sUnsignedValAfter  = "" ; 					// Valeur originale sans le signe apres le point
	
	var iNbBefore          = 0;						// Nombre de chiffre avant le point dans le champs
	var iNbAfter           = 0;						// Nombre de chiffre aprs le point dans le champs
	//var iDotPosition       = GetDotPosition( oField.value );	// Position du point dans le champs
	var iDotPosition       = GetDotPosition( sVal );	// Position du point dans le champs
	
	var iNbBeforeFormat    = 0;						// Nombre de chiffre avant le point dans le format
	var iNbAfterFormat     = 0;						// Nombre de chiffre aprs le point dans le format
	var iDotPositionFormat = GetDotPosition( sFormat );			// Position du point dans le format
	var sUnsignedValFormat = "" ; 					// Valeur originale sans le signe dans le format
	
	var sNewVal            = "";  						// Valeur formate
	
	if ( iDotPositionFormat == -1 )
	{
		alert("ERROR \n function fwkFormatNum() : \n Invalid Format ["+ sFormat +"]");
		return sVal ;
	} 
	
		//--- Sparation du signe et de la valeur non signe du champ 
		sSigne  = sVal.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
		if ( ( sSigne == "-" ) || ( sSigne == "+" ) )  
		{
			sUnsignedVal = sVal.substr(1) ;
			iDotPosition--;
		}
		else
		{
			sSigne = "+" ; // par dfaut 
			sUnsignedVal = sVal ;
		}
		//alert ( "sSigne = "+ sSigne +"\nsUnsignedVal = "+ sUnsignedVal +"\niDotPosition = "+ iDotPosition ) ;
		
		//--- Sparation du signe et de la valeur non signe du format
		sSigneFormat  = sFormat.charAt(0) ; // Aprs controle de validit, le signe (s'il existe) est forcment au dbut
		if ( ( sSigneFormat == "-" ) || ( sSigneFormat == "+" ) )  
		{
			sUnsignedValFormat = sFormat.substr(1) ;
			iDotPositionFormat--;
		}
		else
		{
			sSigneFormat = "+" ; // par dfaut 
			sUnsignedValFormat = sFormat ;
		}
		//alert ( "sSigneFormat = "+ sSigneFormat +"\nsUnsignedValFormat = "+ sUnsignedValFormat +"\niDotPositionFormat = "+ iDotPositionFormat ) ;
		
		//--- Nombre de chiffre avant et aprs le point dans le format
		iNbBeforeFormat = iDotPositionFormat;
		iNbAfterFormat  = ( sUnsignedValFormat.length - iDotPositionFormat - 1);
		
		//alert ( "Format:\niNbBeforeFormat = "+ iNbBeforeFormat +"\niNbAfterFormat = "+ iNbAfterFormat ) ;
		
		// S'il y a un point dans le champ
		if ( iDotPosition > -1 ){
			//--- Nombre de chiffre avant et aprs le point dans le champ
			iNbBefore = iDotPosition;
			iNbAfter  = ( sUnsignedVal.length - iDotPosition - 1);
			//alert ( "Champ:\niNbBefore = "+ iNbBefore +"\niNbAfter = "+ iNbAfter ) ;
						
			sUnsignedValBefore = sUnsignedVal.substr(0, iNbBefore);
			if (iNbBeforeFormat >= iNbBefore){
				for( i=0; i < (iNbBeforeFormat-iNbBefore); i++){
					sUnsignedValBefore = "0"+ sUnsignedValBefore;
				}	
			}
			//alert (sUnsignedValBefore);
		
			sUnsignedValAfter = sUnsignedVal.substr(iDotPosition+1, iNbAfter);
			if (iNbAfterFormat >= iNbAfter){
				for( i=0; i < (iNbAfterFormat-iNbAfter); i++){
					sUnsignedValAfter = sUnsignedValAfter +"0";
				}
			}else
			{
				sUnsignedValAfter=sUnsignedValAfter.substr(0,iNbAfterFormat) ;
			}
			
			//alert (sUnsignedValAfter);
		}
		else {
			//--- Nombre de chiffre avant et aprs le point dans le champ
			iNbBefore = sUnsignedVal.length;
			iNbAfter  = 0;
			//alert ( "Champ:\niNbBefore = "+ iNbBefore +"\niNbAfter = "+ iNbAfter ) ;
			
			sUnsignedValBefore = sUnsignedVal.substr(0, iNbBefore);
			if (iNbBeforeFormat >= iNbBefore){
				for( i=0; i < (iNbBeforeFormat-iNbBefore); i++){
					sUnsignedValBefore = "0"+ sUnsignedValBefore;
				}	
			}
			//alert (sUnsignedValBefore);
		
			for( i=0; i < (iNbAfterFormat - iNbAfter); i++){
				sUnsignedValAfter = sUnsignedValAfter +"0";
			}
			//alert (sUnsignedValAfter);
		}
		
		sNewVal = sUnsignedValBefore +"."+ sUnsignedValAfter		
		
		//--- Mise en place du signe (si ncessaire)
		if ( sFormat.indexOf("+") >= 0 ) // On veut toujours un signe ( + ou - )
		{
			sNewVal = sSigne + sNewVal ;
		}
		else if ( sFormat.indexOf("-") >= 0 ) // On veut un signe uniquement si ngatif ( - )
		{
			if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde le "-" 
		}
		else  // Aucune exigence au niveau du format 
		{
			if  ( sSigne == "-" ) sNewVal = sSigne + sNewVal ; // On garde que le signe "-" 
		}

		//--- Affectation de la valeur formate dans le champ de saisie
		//oField.value = sNewVal ;
		return sNewVal ;
}
//------------------------------------------------------------------------
// Retourne la position du point dans le format
// 		retourne -1 si format invalide (pas de point ou plus de 1 point)
//------------------------------------------------------------------------
function GetDotPosition(sFormat)
{
	var iPos = null;							// Positon du point dans le format 
	var iNbPoint = 0;							// Nombre de point dans le format
	
	for ( i=0; i < sFormat.length; i++)
	{
		if ( sFormat.charAt(i) == "." )
		{
			iPos = i;
			iNbPoint++;
		}
	}
	
	if ( iNbPoint != 1 ) return -1;
	else return iPos;
}

//==============================================================================
//    
//==============================================================================

//------------------------------------------------------------------------
// setFocus() : Selectionne le champ avec la methode select() 
//              quand c'est possible sinon execute la methode focus()
//------------------------------------------------------------------------
function fwkSetFieldFocus( oHtmlObject ){
		if ( oHtmlObject != null ){
		try {
			oHtmlObject.select();
		}
		catch(e) {
			oHtmlObject.focus();
		}
	}
}



//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
// OLD Fonctions 
//------------------------------------------------------------------------
/***
var CaractereDecimal =".";

//------------------------------------------------------------------------
function FormatNum(Chp,NbDecimal) 
{
  if (Chp.value.length == 0) { return true;} // Champ vide
  // Controle de params pour debug :
  // if (arguments.length < 2) { alert('fonction FormatNum : Nombre incorrect de paramtres');return false;} 
  
  if (NombreCaractereDecimal(Chp.value) == 0) { Chp.value = Chp.value + CaractereDecimal ; }
  var i,j = 0;
  i = (Chp.value.length - Chp.value.indexOf(CaractereDecimal) - 1); // Nb chiffres aprs marque dcimale
  for ( j = i ; j < NbDecimal ; j++)
    { Chp.value = Chp.value + "0";}

  return true;
}
***/

//------------------------------------------------------------------------

//------------------------------------------------------------------------
//        F I N 
//------------------------------------------------------------------------
