//------------------------------------------------------------------------------
// fwkScreenRequest.js
//------------------------------------------------------------------------------
// Version : 1.0  ( 12/12/2005 )
// Author  : Laurent Gurin 
// Changes : none (creation)
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// CLASS DEFINITION
//------------------------------------------------------------------------------
function ScreenRequest( )
{
	//==============================================================================
	// PRIVATE ATTRIBUTES
	//==============================================================================
	var _bTrace  = false ;
	
	var _sScreenName = null ;
	var _sScreenId   = null ;
	var _sAction     = null ;
	var _sProcedure  = null ;
	
	var _sFlagGet    = null ;
	var _sFlagSet    = null ;
	var _sFlagClear  = null ;
	
	var _oParameters = new Object();

	var _sDataTags   = null ;
	
	//==============================================================================
	// PRIVATE METHODS 
	//==============================================================================
	function _trace ( sMsg ) 
	{
		if ( _bTrace ) alert ( "TRACE : \n\n" + sMsg ) ;
	}
	
	//==============================================================================
	// PUBLIC / PRIVILEGED  METHODS 
	//==============================================================================
	this.setScreenName = function ( s ) 
	{
		_sScreenName = s ;
	}
	//------------------------------------------------------------------------------
	this.setScreenId = function ( s ) 
	{
		_sScreenId = s ;
	}
	//------------------------------------------------------------------------------
	this.setAction = function ( s ) 
	{
		_sAction = s ;
	}
	//------------------------------------------------------------------------------
	this.setProcedure = function ( s ) 
	{
		_sProcedure = s ;
	}
	//------------------------------------------------------------------------------
	this.setFlagGet = function ( s ) 
	{
		_sFlagGet = s ;
	}
	//------------------------------------------------------------------------------
	this.setFlagSet = function ( s ) 
	{
		_sFlagSet = s ;
	}
	//------------------------------------------------------------------------------
	this.setFlagClear = function ( s ) 
	{
		_sFlagClear = s ;
	}
	//------------------------------------------------------------------------------
	this.setParameter = function ( sName, sValue ) 
	{		
		_trace ( "setParameter : " + sName + "=" + sValue ) ;
		if ( sName == null )
		{
			alert ( "ERROR: setParameter() : name = null" );
			return ;
		}
		if ( sValue == null )
		{
			alert ( "ERROR: setParameter() : value = null" );
			return ;
		}
		_oParameters[sName] = sValue ;
	}
	//------------------------------------------------------------------------------
	this.clearParameters = function () 
	{		
		_trace ( "clearParameters " ) ;
		_oParameters = new Object(); ;
	}
	//------------------------------------------------------------------------------
	this.showParameters = function () 
	{
		var sParams = "PARAMETERS : \n" ;
		for ( p	in _oParameters )
		{
			sParams += p + "=" + _oParameters[p] + "\n" ;
		}
		alert( sParams ); 
	}

	//------------------------------------------------------------------------------
	// Data XML Tags ( to be inserted between <data> and </data> )
	//------------------------------------------------------------------------------
	this.setData = function ( s ) 
	{
		_trace ( "setData() : \n" + s ) ;
		_sDataTags = s ;
	}
	//------------------------------------------------------------------------------
	this.clearData = function ( s ) 
	{
		_trace ( "clearData()" ) ;
		_sDataTags = null ;
	}
	//------------------------------------------------------------------------------
	this.showData = function () 
	{
		alert ( "DATA : \n" + _sDataTags ) ;
	}
		
	//------------------------------------------------------------------------------
	// Build and return the XML Request
	//------------------------------------------------------------------------------
	this.getXmlRequest = function () 
	{
		var sXml = "<request " 
			+ " screen-name=\"" + _sScreenName + "\" " 
			+ " screen-id=\""   + _sScreenId   + "\" " 
			+ " action=\""      + _sAction     + "\" " ;
		if ( _sAction.toLowerCase() == "exec" ) 
		{
			if ( _sProcedure != null ) 
			{
				sXml += " proc-name=\"" + _sProcedure + "\" " ;
			}
			else
			{
				alert("WARNING : action 'exec' without procedure name ! ");
			}
		}
		if ( _sFlagGet != null ) 
		{
			sXml += " get=\"" + _sFlagGet + "\" " ;
		}
		if ( _sFlagSet != null ) 
		{
			sXml += " set=\"" + _sFlagSet + "\" " ;
		}
		if ( _sFlagClear != null ) 
		{
			sXml += " clear=\"" + _sFlagClear + "\" " ;
		}		
		sXml += " > \n" ;

		//--- Parameters list 
		var sParams = "" ;
		var iParamsCount = 0 ;
		for ( p	in _oParameters )
		{
			sParams += "<param " + p + "=\"" + _oParameters[p] + "\" />\n" ;
			iParamsCount++ ;
		}
		if ( iParamsCount > 0 ) 
		{
			sXml += "<params>\n" ;
			sXml += sParams ;
			sXml += "</params>\n" ;			
		}
		
		//--- Data Tags ( 1 to N )
		if ( _sDataTags != null )
		{
			sXml += "<data>\n" ;
			sXml += _sDataTags ;
			sXml += "</data>\n" ;						
		}
		
		//--- End of requet
		sXml += "</request>\n" ;
		
		_trace( "getXmlRequest() : \n" + sXml ); 
		return sXml ;
	}
	
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	
}
//------------------------------------------------------------------------------
//                                  F  I  N
//------------------------------------------------------------------------------
