package org.objectweb.telosys.auth;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.objectweb.telosys.common.TelosysServlet;

/**
 * Servlet to check the user authentication.<br>
 * If the authentication is OK => Redirect the user to its first page<br>
 * else => Send a "401-Unauthorized" response
 * @author Laurent GUERIN
 *
 */
public class AuthServlet extends TelosysServlet // HttpServlet
{
    //---------------------------------------------------------------------------
    public void doGet(HttpServletRequest request, HttpServletResponse response)
    {
        trace("========================================");
        trace("doGet()");
        process(request, response);
    }

    //---------------------------------------------------------------------------
    public void doPost(HttpServletRequest request, HttpServletResponse response)
    {
        trace("========================================");
        trace("doPost()");
        process(request, response);
    }

    //---------------------------------------------------------------------------
    public void destroy()
    {
        trace("destroy()");
    }

    //---------------------------------------------------------------------------
    private void process(HttpServletRequest request, HttpServletResponse response)
    {
        trace("process() -> check authentication");
        Auth.checkAuthentication(request, response);
    }
}