package org.objectweb.telosys.auth;

import java.util.Properties;

import org.objectweb.telosys.common.Telosys;

/**
 * Authentication layer manager ( initialization and configuration ) 
 * 
 * @author Laurent GUERIN
 *  
 */
public final class TelosysAUTH
{
    //--- Realm Name for "basic HTTP" authentication
    private static String $sRealmName = "";

    //--- Default First Page
    private static String $sFirstPage = null;

    //-----------------------------------------------------------------------------
    private static boolean initWithProperties(Properties prop)
    {
        boolean bRet = true;

        //--- Realm Name for "basic HTTP" authentication
        $sRealmName = prop.getProperty("RealmName");
        if ($sRealmName == null)
        {
            Telosys.error("TelosysAUTH - init : Realm name not found ");
            bRet = false;
        }

        //--- Default First Page
        $sFirstPage = prop.getProperty("FirstPage");
        if ($sFirstPage == null)
        {
            Telosys.error("TelosysAUTH - init : First page not found ");
            bRet = false;
        }

        return bRet;
    }

    //-----------------------------------------------------------------------------
    // PUBLIC METHODS
    //-----------------------------------------------------------------------------
    public static boolean init()
    {
        Telosys.info("TelosysAUTH : INIT without properties ...");
        //--- Get the Telosys properties ...
        Properties prop = Telosys.getProperties();
        if (prop != null)
        {
            return initWithProperties(prop);
        }
        else
        {
            Telosys.error("TelosysAUTH.init() : cannot get Telosys properties !");
            return false;
        }
    }

    //-----------------------------------------------------------------------------

    //-----------------------------------------------------------------------------
    // PUBLIC GETTERS
    //-----------------------------------------------------------------------------
    public static String getFirstPage()
    {
        return $sFirstPage;
    }

    public static String getRealmName()
    {
        return $sRealmName;
    }
    //-----------------------------------------------------------------------------
}