package org.objectweb.telosys.common;

/**
 * Console can be used to print trace, info and error messages
 * 
 * @author Laurent GUERIN
 *  
 */

import java.io.PrintStream;

public final class Console
{
    public static final PrintStream out = System.out;

    /**
     * Print a trace message
     * @param sClassName
     * @param sMsg
     */
    public static void trace(String sClassName, String sMsg)
    {
        println("Trace : [" + sClassName + "] " + sMsg);
    }

    /**
     * Print a trace message
     * @param sMsg
     */
    public static void trace(String sMsg)
    {
        println("Trace : " + sMsg);
    }

    /**
     * Print an error message
     * @param sClassName
     * @param sMsg
     */
    public static void error(String sClassName, String sMsg)
    {
        println("ERROR : [" + sClassName + "] " + sMsg);
    }

    /**
     * Print an error message
     * @param sMsg
     */
    public static void error(String sMsg)
    {
        println("ERROR : " + sMsg);
    }

    /**
     * Print an info message
     * @param sClassName
     * @param sMsg
     */
    public static void info(String sClassName, String sMsg)
    {
        println("info  : [" + sClassName + "] " + sMsg);
    }

    /**
     * Print an info message
     * @param sMsg
     */
    public static void info(String sMsg)
    {
        println("info  : " + sMsg);
    }

    /**
     * Print a String
     * @param s
     */
    public static void println(String s)
    {
        System.out.println(s);
        System.out.flush();
    }
}