package org.objectweb.telosys.common;

import org.objectweb.telosys.auth.IUserValidator;
import org.objectweb.telosys.rpl.xml.IXmlWrapperProvider;
import org.objectweb.telosys.screen.core.IScreenDataProvider;
import org.objectweb.telosys.screen.core.IScreenProvider;
import org.objectweb.telosys.service.IServiceProvider;

/**
 * @author Laurent GUERIN
 * 
 * Centralize the getters to obtain all the Factory providers needed by the framework <br>
 * This interface must be implemented by only one class of the application <br>
 * 
 */
public interface IExternalMainFactory
{
    public IUserValidator getUserValidator();

    public IXmlWrapperProvider getXmlWrapperProvider();

    public IScreenDataProvider getScreenDataProvider();

    public IScreenProvider getScreenProvider();

    public IServiceProvider getServiceProvider();

}