package org.objectweb.telosys.common;

/**
 * @author Laurent GUERIN
 *
 */
public class TelosysClassLogger {
    
    private String   _sClassName             = "???";
    private int      _iLastTraceConfigState  = -1 ; 
    private boolean  _bTrace                 = false ;


    /**
     * Constructor
     * @param cl
     */
    public TelosysClassLogger(Class cl)
    {
        if ( cl != null )
        {
            _sClassName = cl.getName() ;            
        }
    }
    
    public void trace(String s)
    {
        //--- If the configuration has changed since the last acces ...
        if ( TraceConfig.getCurrentState() != _iLastTraceConfigState )
        {
          //--- ScreenTitle the flag from the configuration
          _bTrace = TraceConfig.flagIsOn(_sClassName);
          //--- ScreenTitle the configuration state
          _iLastTraceConfigState = TraceConfig.getCurrentState();
        }
        if ( _bTrace == true )
        {
            Telosys.trace ( _sClassName, s );
        }        
    }
    
    public void error(String s)
    {
        Telosys.error ( _sClassName, s );
    }
    
    public void info(String s)
    {
        Telosys.info ( _sClassName, s );
    }
}