package org.objectweb.telosys.dal.dao;


/**
 * @author Laurent GUERIN
 * 
 */
public interface ListQuery
{
    /**
     * Return the SQL request "select ... from ..."
     * @return
     */
    public String getSqlSelect();

    /**
     * Return the SQL request "delete from ..."
     * @return
     */
    public String getSqlDelete();

    /**
     * Return the SQL request "select count(*) from ..."
     * @return
     */
    public String getSqlCount();

    /**
     * Get the value of a parameter 
     * @param iIndex index of the parameter ( 0 to Size-1 ) 
     * @return the value
     */
    public Object getParameter(int iIndex);

    /**
     * Set the value of a parameter 
     * @param iIndex index of the parameter to set ( 0 to Size-1 ) 
     * @param oValue value of the parameter
     */
    public void setParameter(int iIndex, Object oValue);

    /**
     * Return the query parameters as an array
     * @return
     */
    public Object[] getParametersArray();

    /** 
     * Return the query parameters as a String
     * @return
     */
    public String getParametersString();

}