package org.objectweb.telosys.dal.dao;


/**
 * @author Laurent GUERIN
 * 
 * Standard implementation of ListQuery
 *  
 */
public class StandardQuery implements ListQuery
{
    //--- SQL request to SELECT the elements of the list
    private String   _SqlSelect = "";

    //--- SQL request to delete the elements of the list
    private String   _SqlDelete = "";

    //--- SQL request to count the elements of the list
    private String   _SqlCount  = "";

    //--- Key columns ( query parameters )
    private Object[] _params    = null;

    //-----------------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //-----------------------------------------------------------------------------
    public StandardQuery(int iKeySize, String sSqlSelectData, String sSqlSelectCount, String sSqlDelete)
    {
        if ( iKeySize < 0 )
        {            
            _params = new Object[0];            
        }
        else
        {
            _params = new Object[iKeySize];            
        }
        _SqlSelect = sSqlSelectData;
        _SqlCount = sSqlSelectCount;
        _SqlDelete = sSqlDelete;
    }

    //-----------------------------------------------------------------------------
    // INTERFACE IMPLEMENTATION
    //-----------------------------------------------------------------------------
    public Object[] getParametersArray()
    {
        Object[] paramsCopy = (Object[]) _params.clone();
        return paramsCopy;
    }

    //-----------------------------------------------------------------------------
    public String getParametersString()
    {
        StringBuffer sb = new StringBuffer(128);
        sb.append("[");
        for ( int i = 0 ; i < _params.length ; i++ )
        {
            Object obj = _params[i];
            if (i > 0)
            {
                sb.append("|");
            }
            if ( obj == null )
            {                
                sb.append("(null)");                
            }
            else
            {
                sb.append(obj.toString());                
            }
        }
        sb.append("]");
        return sb.toString();
    }

    //-----------------------------------------------------------------------------
    public String getSqlSelect()
    {
        return _SqlSelect;
    }

    //-----------------------------------------------------------------------------
    public String getSqlDelete()
    {
        return _SqlDelete;
    }

    //-----------------------------------------------------------------------------
    public String getSqlCount()
    {
        return _SqlCount;
    }

    //-----------------------------------------------------------------------------
    public void setParameter(int iIndex, Object oValue)
    {
        if ( iIndex < _params.length )
        {
            _params[iIndex] = oValue ;            
        }
    }

    //-----------------------------------------------------------------------------
    public Object getParameter(int iIndex)
    {
        return _params[iIndex];
    }

}