package org.objectweb.telosys.dal.dataset;

/**
 * @author Laurent GUERIN
 *  
 */
public class SQLCriteria
{
    // SQL where criteria ( ie : "agency = ?" )
    private String  _sCriteria   = null;

    private int     _iType       = -1;

    private String  _sParamValue = null;

    private boolean _bUsed       = false;

    /**
     * @param columnName
     * @param columnType
     */
    public SQLCriteria(String sCriteria, int iType)
    {
        super();
        _sCriteria = sCriteria;
        _iType = iType;
    }

    public String getCriteria()
    {
        return _sCriteria;
    }

    public int getCriteriaType()
    {
        return _iType;
    }

    public String getParamValue()
    {
        return _sParamValue ;
    }

    public void useWithValue(String sParamVal)
    {
        _sParamValue = sParamVal;
        _bUsed = true;
    }

    public void doNotUse()
    {
        _sParamValue = null;
        _bUsed = false;
    }

    public boolean isUsed()
    {
        return _bUsed ;
    }
}