package org.objectweb.telosys.dal.sql;

import java.util.*;
import java.sql.*;

/**
 * @author Laurent GUERIN
 *  
 */

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
public class SqlConnectionFactory extends SqlConnectionProvider
{
    //-----------------------------------------------------------------------------
    /**
     * Constructor, pool creation 
     * @param sName
     * @param sDriver
     * @param sUrl
     * @param prop
     * @param iIsolationLevel
     */
    public SqlConnectionFactory(String sName, String sDriver, String sUrl, Properties prop, int iIsolationLevel)
    {
        super(sName, sDriver, sUrl, prop, iIsolationLevel);
        trace("Constructor...");
    }

    //-----------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.sql.SqlConnectionProvider#getConnection()
     */
    //public synchronized SqlConnection getConnection() throws Exception
    public synchronized Connection getConnection() throws Exception
    {
        trace("getConnection()");
        Connection stdCon = createStandardJdbcConnection();
        return new SqlConnection(stdCon);
    }

    //-----------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.sql.SqlConnectionProvider#isPool()
     */
    public boolean isPool()
    {
        return false; // No it's not a pool
    }

}