package org.objectweb.telosys.rpl;

import java.util.Hashtable;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.common.TelosysObject;

/**
 * @author Laurent GUERIN
 * 
 */
public class ScreenRequestParameters extends TelosysObject
{
    private Hashtable      _htParameters = null;

    /**
     *  
     */
    public ScreenRequestParameters()
    {
    }

    //-----------------------------------------------------------------------------------------------
    public void setParameter(String sParamName, String sParamValue)
    {
        if (_htParameters == null)
        {
            _htParameters = new Hashtable();
        }
        if (_htParameters != null)
        {
            _htParameters.put(sParamName, sParamValue);
        }
        else
        {
            error("Cannot create parameters Hashtable !");
        }
    }

    //-----------------------------------------------------------------------------------------------
    public String getParameter(String sParamName)
    {
        String sVal = null ;
        if (_htParameters != null)
        {
            sVal = (String) _htParameters.get(sParamName);
        }
        return sVal ;        
    }

    //-----------------------------------------------------------------------------------------------
    public int getIntParameter(String sParamName) throws TelosysException
    {
        int iVal = 0 ;
        String sVal = getParameter(sParamName) ;
        if (sVal == null)
        {
            throw new TelosysException("ScreenRequest parameter '" + sParamName + "' not found !");
        }
        else
        {
            try
            {
                iVal = Integer.parseInt(sVal);
            } catch (NumberFormatException e)
            {
                throw new TelosysException("Cannot convert ScreenRequest parameter '" + sParamName + "' to int (value=" + sVal + ") !");
            }
        }
        return iVal ;
    }
    //-----------------------------------------------------------------------------------------------
    /**
     * Return the number of parameters 
     * @return parameters count ( 0 to N )
     */
    public int count()
    {
        return _htParameters.size() ;
    }
    //-----------------------------------------------------------------------------------------------
    public String toString()
    {
        //--- Parameters
        String sParameters = "(no parameter)";
        if (this._htParameters != null)
        {
            sParameters = _htParameters.toString();
        }
        return sParameters;
    }
    //-----------------------------------------------------------------------------------------------
}