package org.objectweb.telosys.rpl;

import org.objectweb.telosys.common.Telosys;
import org.objectweb.telosys.common.TelosysFactory;
import org.objectweb.telosys.rpl.xml.IXmlWrapperProvider;

/**
 * @author Laurent GUERIN
 * 
 */
public final class TelosysRPL
{
    //-----------------------------------------------------------------------------
    // PUBLIC METHODS
    //-----------------------------------------------------------------------------
    /**
     * R.P.L. initialization ( load the XML Wrappers )
     * @return
     */
    public static boolean init()
    {
        Telosys.info("TelosysRPL : INIT ..." );
        TelosysFactory factory = Telosys.getFactory();
        if (factory != null)
        {
            IXmlWrapperProvider wrapperProvider = factory.getXmlWrapperProvider();
            if ( wrapperProvider != null )
            {
                Telosys.info("TelosysRPL : INIT OK" );
                return true ;
            }
        }
        Telosys.info("TelosysRPL : INIT ERROR ( Cannot get Wrapper Provider )!" );
        return false ;
    }
    //-----------------------------------------------------------------------------
}