package org.objectweb.telosys.rpl.xml;

import java.io.PrintWriter;
import java.util.Hashtable;

import org.objectweb.telosys.common.TelosysObject;
import org.objectweb.telosys.rpl.ScreenRequest;

/**
 * @author Laurent GUERIN
 *
 */
public class RequestParamXmlWrapper extends TelosysObject implements IXmlWrapper
{
    private ScreenRequest _screenRequest = null ;
    
    /**
     * @param _bean
     */
    public RequestParamXmlWrapper( ScreenRequest screenRequest )
    {
        super();
        this._screenRequest = screenRequest;
    }

    //-----------------------------------------------------------------------------------
	public void newXmlChild ( String sTagName, IXmlWrapper obj )
	{
	    // ERROR : NOTHING TO DO ( no child for this bean )
	    error("newChild invocation for tag " + sTagName + " ! ");
	}
	//-----------------------------------------------------------------------------------
    public Object getObject ()
    {
        // return _bean ;
        return null ;
    }

	//-----------------------------------------------------------------------------------
	// Affectation des valeurs recues via XML
	// ( c'est le parser traduit les "entits XML" en caractres standards => aucune conversion ncessaire)
	//-----------------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see org.telosys.xml.IXmlWrapper#setXmlFieldValue(java.lang.String, java.lang.String)
	 */
	//-----------------------------------------------------------------------------------
	public void setXmlFieldValue(final String sName, final String sValue)
	{
	    if ( _screenRequest == null )
	    {
	        error("setXmlFieldValue("+sName+","+sValue+") : _screenRequest is NULL !" );
	    }
	    else
	    {
			if ( sName != null && sValue != null )
			{
			    _screenRequest.setParameter( sName, sValue );
			    
			    Hashtable ht = new Hashtable();
			    ht.put(sName, sValue );
			}	        
	    }
	}

	//-----------------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see org.objectweb.telosys.rpl.xml.IXmlWrapper#toXml(java.io.PrintWriter, java.lang.Object, java.lang.String)
	 */
	public void toXml(PrintWriter out, Object bean, String sTagName)
	{
	    // No XML output for this wrapper
        out.println("<!-- ERROR : toXml(out,bean) on RequestParamXmlWrapper object -->");                        
	}
	//-----------------------------------------------------------------------------------
//	public void toXml(PrintWriter out )
//	{
//	    // No XML output for this wrapper
//        out.println("<!-- ERROR : toXml(out) on RequestParamXmlWrapper object -->");                        
//	}

	//-----------------------------------------------------------------------------------
//    public String getXmlTagName() // Not used
//    {
//        return "request" ;
//    }
	//-----------------------------------------------------------------------------------	
}
