package org.objectweb.telosys.rpl.xml;

import java.io.PrintWriter;

import org.objectweb.telosys.common.TelosysObject;
import org.objectweb.telosys.rpl.ScreenRequest;

/**
 * @author Laurent GUERIN
 *  
 */
public class ScreenRequestXmlWrapper extends TelosysObject implements IXmlWrapper
{
    private ScreenRequest _request = null;

    /**
     * @param _request
     */
    public ScreenRequestXmlWrapper(ScreenRequest screenRequest)
    {
        super();
        this._request = screenRequest;
    }

    //-----------------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.rpl.xml.IXmlWrapper#newXmlChild(java.lang.String, org.objectweb.telosys.rpl.xml.IXmlWrapper)
     */
    public void newXmlChild(String sTagName, IXmlWrapper obj)
    {
        // NOTHING TO DO ( no child for this bean )
        trace("newChild invocation for tag " + sTagName + " ! ");
    }

    //-----------------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.rpl.xml.IXmlWrapper#getObject()
     */
    public Object getObject()
    {
        return _request;
    }

    //-----------------------------------------------------------------------------------

    //-----------------------------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see org.telosys.xml.IXmlWrapper#setXmlFieldValue(java.lang.String, java.lang.String)
     */
    //-----------------------------------------------------------------------------------
    public void setXmlFieldValue(final String sFieldName, final String sFieldValue)
    {
        if (sFieldName.equalsIgnoreCase("screen-name"))
        {
            _request.setScreenName(sFieldValue.trim());
        }
        else if (sFieldName.equalsIgnoreCase("screen-id"))
        {
            _request.setScreenId(sFieldValue.trim());
        }
        else if (sFieldName.equalsIgnoreCase("action"))
        {
            _request.setAction(sFieldValue.trim());
        }
        else if (sFieldName.equalsIgnoreCase("proc-name"))
        {
            _request.setProcName(sFieldValue.trim());
        }
        else if (sFieldName.equalsIgnoreCase("elements"))
        {
            _request.setElements(sFieldValue.trim());
        }
        else if (sFieldName.equalsIgnoreCase("set"))
        {
            _request.setFlagSetData(sFieldValue.trim());
        }
        else if (sFieldName.equalsIgnoreCase("get"))
        {
            _request.setFlagGetData(sFieldValue.trim());
        }
        else if (sFieldName.equalsIgnoreCase("clear"))
        {
            _request.setFlagClearData(sFieldValue.trim());
        }

    }

    //-----------------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.rpl.xml.IXmlWrapper#toXml(java.io.PrintWriter, java.lang.Object, java.lang.String)
     */
    public void toXml(PrintWriter out, Object bean, String sTagName)
    {
        // No XML output for this wrapper
        out.println("<!-- ERROR : toXml(out,bean) on ScreenRequestXmlWrapper object -->");
    }

    //-----------------------------------------------------------------------------------
//    public void toXml(PrintWriter out)
//    {
//        // No XML output for this wrapper
//        out.println("<!-- ERROR : toXml() on ScreenRequestXmlWrapper object -->");
//    }

    //-----------------------------------------------------------------------------------
//    public String getXmlTagName() // Not used
//    {
//        return "request";
//    }
    //-----------------------------------------------------------------------------------
}