package org.objectweb.telosys.screen.core;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.rpl.ScreenRequest;
import org.objectweb.telosys.rpl.ScreenResponse;

/**
 * @author Laurent GUERIN
 *
 */
public interface ScreenActions
{
    public void actionSet(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionGet(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionClear(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionLoad(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionSave(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionSaveCurrent(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionInsert(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionUpdate(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;

    public void actionDelete(ScreenContext screen, ScreenRequest request, ScreenResponse response ) throws TelosysException ;

    public void actionDeleteCurrent(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException ;
    
    public void actionExec(ScreenContext screen, ScreenRequest request, ScreenResponse response) throws TelosysException;


}
