package org.objectweb.telosys.screen.core;

import java.io.PrintWriter;

/**
 * ScreenData interface
 * 
 * @author Laurent GUERIN
 *  
 */
public interface ScreenData 
{
    /**
     * Set the new element instance for the given element name
     * @param sElementName
     * @param oElementInstance
     */
    public void setElement(String sElementName, Object oElementInstance);

    /**
     * Returns the element instance referenced by the given name
     * @param sElementName
     * @return
     */
    public Object getElement(String sElementName) ;
    
    /**
     * Returns the class of the element referenced by the given name
     * @param sElementName
     * @return
     */
    public Class getElementClass(String sElementName) ;

    /**
     * Returns the ScreenDataElement object for the given name
     * @param sElementName
     * @return
     */
    public ScreenDataElement getScreenDataElement(String sElementName);

    /**
     * Returns the list of all the elements defined for the ScreenData  
     * @return
     */
    public ScreenDataElements getElements(); 

    /**
     * Copy all the elements to an other ScreenData 
     * @param destination : where to copy the elements
     */
    public void copyElementsTo( ScreenData destination) ;

    public void toXml(PrintWriter out) ;

    public void setFound();

    public void setNotFound();

    public boolean isFound();

}

