package org.objectweb.telosys.screen.core;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.objectweb.telosys.common.TelosysObject;

/**
 * @author Laurent GUERIN
 *  
 */
public class ScreenDataElements extends TelosysObject
{
    private ArrayList _elements = null;

    /**
     * Default constructor
     */
    public ScreenDataElements()
    {
        super();
        _elements = new ArrayList();
    }

    /**
     * Constructor from elements collection
     * @param elements
     */
    public ScreenDataElements(Collection elements)
    {
        super();
        _elements = new ArrayList(elements);        
    }
    
    //-----------------------------------------------------------------------------------------------
    public void add(ScreenDataElement oElement)
    {
        _elements.add(oElement);
    }

    //-----------------------------------------------------------------------------------------------
    public int size()
    {
        return _elements.size();
    }

    //-----------------------------------------------------------------------------------------------
    public ScreenDataElement get(int index)
    {
        return (ScreenDataElement) _elements.get(index);
    }

    //-----------------------------------------------------------------------------------------------
    public Iterator iterator()
    {
        return _elements.iterator();
    }

}