
package org.objectweb.telosys.screen.core;

import org.objectweb.telosys.dal.dao.DatabaseSession;
import org.objectweb.telosys.rpl.ScreenRequest;
import org.objectweb.telosys.rpl.ScreenResponse;

/**
 * @author Laurent GUERIN
 *
 * This class is the default implementation of the ScreenTriggers interface.<br>
 * It provides a set of methods to be overrided.<br>
 * Void triggers ( all the triggers do "nothing" and always return "true" )<br>
 * 
 * 
 */
public class StandardScreenTriggers implements ScreenTriggers
{
    public boolean beforeSet(ScreenData data, ScreenContext screen, ScreenRequest request, ScreenResponse response )
    {
        return true;
    }

    public boolean afterSet(ScreenData data, ScreenContext screen, ScreenRequest request, ScreenResponse response )
    {
        return true;            
    }        
    
    public boolean beforeGet( ScreenContext screen, ScreenRequest request, ScreenResponse response )
    {
        return true;
    }

    public boolean afterGet( ScreenContext screen, ScreenRequest request, ScreenResponse response )
    {
        return true;            
    }        
    
    public boolean beforeClear( ScreenContext screen, ScreenRequest request, ScreenResponse response )
    {
        return true;
    }

    public boolean afterClear( ScreenContext screen, ScreenRequest request, ScreenResponse response )
    {
        return true;            
    }        
    
    public boolean beforeLoad(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean afterLoad(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean beforeSave(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean afterSave(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean beforeInsert(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean afterInsert(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean beforeUpdate(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean afterUpdate(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean beforeDelete(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }

    public boolean afterDelete(ScreenData data, ScreenContext screen, ScreenRequest req, ScreenResponse response, DatabaseSession dbSession)
    {
        return true;
    }


}
