package org.objectweb.telosys.screen.env;

import java.util.Hashtable;

import javax.servlet.ServletContext;

import org.objectweb.telosys.common.TelosysObject;

/**
 * @author Laurent GUERIN
 *  
 */
public class ScreenApplication extends TelosysObject
{
    private ServletContext _servletContext = null;

    //--- Open storage space (to store anything)
    private Hashtable      _htData         = new Hashtable();

    //---------------------------------------------------------------------------
    /**
     * Constructor 
     * @param context
     */
    public ScreenApplication(ServletContext context)
    {
        _servletContext = context;
    }

    /**
     * Return the ServletContext (WebApp context) linked with the ScreenApplication
     * @return
     */
    public ServletContext getServletContext()
    {
        return _servletContext;
    }

    //---------------------------------------------------------------------------
    // get/set/clear every types of data
    //---------------------------------------------------------------------------
    /**
     * Store an object in the ScreenApplication  
     * @param key
     * @param value
     * @return
     */
    public Object put(Object key, Object value)
    {
        return _htData.put(key, value);
    }

    /**
     * Retrieve an object from the ScreenApplication 
     * @param key
     * @return
     */
    public Object get(Object key)
    {
        return _htData.get(key);
    }

    /**
     * Remove an object from the ScreenApplication     
     * @param key
     * @return
     */
    public Object remove(Object key)
    {
        return _htData.remove(key);
    }

    /**
     * Close the ScreenApplication (clean all the references held)
     */
    public void close()
    {
        _htData = null;
        _servletContext = null;
    }
    //---------------------------------------------------------------------------
}