package org.objectweb.telosys.uil.taglib.old;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.screenmap.ScreenMap;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 * 
 */
public class UseScreenActions extends CommonTagSupport
{
    private String _sVar = null;
    
    public void setVar(String v) // Attribute "var"
    {
        _sVar = v; 
    }

    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        ScreenMap screenMap = getScreenMap();
        if (screenMap == null)
        {
            tagLibError ( "ScreenMap == null ! ") ;
            return (SKIP_BODY);
        }

        //--- Current screen name & screen id
        String sScreenName = screenMap.getName() ;
        int iScreenId   = screenMap.getScreenContextId();
        if ( sScreenName == null )
        {
            tagLibError ( "Screen name == null ! ") ;
            return (SKIP_BODY);
        }
        if ( iScreenId < 0 )
        {
            tagLibError ( "Invalid Screen id == " + iScreenId + " !") ;
            return (SKIP_BODY);
        }
        
        //--- Javascript variable name for "screen actions"
        String sVarName = _sVar ;
        if ( sVarName == null )
        {
            sVarName = "actions" ;
        }
        
        println(out, "<!-- useScreenAction -->");
        println(out, "<script type=\"text/javaScript\">" );
        println(out, "  var " + sVarName + " = telosys.getActions( '" + sScreenName + "', " + iScreenId + "); " );
        println(out, "</script>");        
        
        return (SKIP_BODY);
    }
}