package org.objectweb.telosys.uil.taglib.todo;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.TelosysUIL;
import org.objectweb.telosys.uil.screenmap.ScreenDefRootDir;
import org.objectweb.telosys.uil.screenmap.ScreenDefinitions;
import org.objectweb.telosys.uil.screenmap.ScreenMap;
import org.objectweb.telosys.uil.screenmap.ScreenMapConst;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 *  
 */
public class TagScreenInclude extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    private String _sBody = null;

    private String _sPart = null;

    private String _sType = null;

    public void setBody(String v)
    {
        _sBody = v;
    }

    public void setPart(String v)
    {
        _sPart = v;
    }

    public void setType(String v)
    {
        _sType = v;
    }

    //----------------------------------------------------------------
    // TAG open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();
        println(out, "");
        print(out, "<!-- [screen:include] ");
        String sAttribute = null;
        if (_sBody != null)
        {
            sAttribute = _sBody;
            print(out, "body='" + sAttribute + "'");
        }
        else if (_sPart != null)
        {
            sAttribute = _sBody;
            print(out, "part='" + sAttribute + "'");
        }
        else
        {
            print(out, "NO FILE ATTRIBUTE");
        }
        if (_sType != null)
        {
            print(out, " type='" + _sType + "' ");
        }
        println(out, " -->");

        if (sAttribute == null)
        {
            return (SKIP_BODY);
        }

        //--- Get the Screen Definitions
        ScreenDefinitions screenDefinitions = TelosysUIL.getScreenDefinitions();

        //--- Get the Root Directory for the screen type
        //ScreenDefRootDir rootDir = null;
        String sType ;
        if (_sType != null)
        {
            //--- Explicit type => use it
            sType = _sType ;
            //rootDir = screenDefinitions.getRootDir(_sType);
        }
        else
        {
            //--- No explicit type => use screen map type
            ScreenMap screenMap = getScreenMap(SILENT);
            if (screenMap == null)
            {
                // No screen map => use default type : HTML
                sType = ScreenMapConst.HTML_SCREEN_TYPE ;
                //rootDir = screenDefinitions.getHtmlRootDir();
            }
            else
            {
                if (screenMap.isXulType())
                {
                    sType = ScreenMapConst.XUL_SCREEN_TYPE ;
                    //rootDir = screenDefinitions.getXulRootDir();
                }
                else
                {
                    // Default = HTML
                    sType = ScreenMapConst.HTML_SCREEN_TYPE ;
                    //rootDir = screenDefinitions.getHtmlRootDir();
                }
            }
        }
        
        ScreenDefRootDir rootDir = screenDefinitions.getRootDir(sType);
        if ( rootDir == null )
        {
            tagLibMessage( "Cannot get 'RootDir' object from Screen Definitions");
            return (SKIP_BODY);
        }

        //--- Build the target URL
        String sIncludePath = null;
        if (_sBody != null)
        {
            sIncludePath = rootDir.getBodyPath(jspFile(_sBody));
        }
        else if (_sPart != null)
        {
            //TODOsURL = rootDir.getPartPath( jspFile(_sPart) ); 
        }

        if (sIncludePath != null)
        {
            println(out, "<!-- [screen:include]  ( include '" + sIncludePath + "' ) -->");
            //--- INCLUDE
            include(sIncludePath);
        }
        else
        {
            tagLibError("Cannot get the page path for include");
        }
        return (SKIP_BODY);

    }

    //---------------------------------------------------------------------------
    private String jspFile(String sName)
    {
        if (sName != null)
        {
            if (sName.indexOf('.') < 0) // No "."
            {
                return sName + ".jsp";
            }
            else
            {
                return sName;
            }
        }
        else
        {
            return null;
        }
    }
    //---------------------------------------------------------------------------
}