package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.screenmap.ScreenMap;
import org.objectweb.telosys.uil.screenmap.ScreenMapElement;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 * 
 */
public class Element extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    private String _sName = null;

    public void setName(String v) // Attribute "name"
    {
        _sName = v; 
    }

    //----------------------------------------------------------------
    // TAG open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        ScreenMap screen = getScreenMap();
        if (screen == null)
        {
            return (SKIP_BODY);
        }

        if (_sName == null) 
        {
            tagLibError("Element name is not set !");
            return (SKIP_BODY);
        }
        
        //--- Does the element exist ? 
        ScreenMapElement element = screen.getElement(_sName);
        if ( element == null )
        {
            tagLibError("Element '" + _sName + "' not found ");
            return (SKIP_BODY);            
        }
        
        //--- What kind of  element : value or content ? 
        if (element.isValue())
        {
            //--- Print the element VALUE
            String sElementValue = element.getValue();
            if (sElementValue != null)
            {
                print(out, sElementValue);
            }
            else
            {
                print(out, "(null)");
            }
        }
        else if (element.isContent())
        {
            //--- Include the element CONTENT
            String sElementURL = element.getContent();
            if (sElementURL != null)
            {
                include(sElementURL);
            }
            else
            {
                tagLibError("Element content is not set !");
            }
        }

        return (SKIP_BODY);
    }
}