package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.screenmap.ScreenMap;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author Laurent GUERIN
 *  
 */
public class InitEnv extends CommonTagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sVarActions  = null;

    private String _sVarScreen   = null;

    private String _sVarKeyboard = null;

    private String _sVarBrowser  = null;

    //----------------------------------------------------------------
    // Attributes setters
    //----------------------------------------------------------------
    public void setVar_actions(String v)
    {
        _sVarActions = v;
    }

    public void setVar_screen(String v)
    {
        _sVarScreen = v;
    }

    public void setVar_keyboard(String v)
    {
        _sVarKeyboard = v;
    }

    public void setVar_browser(String v)
    {
        _sVarBrowser = v;
    }

    //----------------------------------------------------------------
    // Generation
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        println(out, "");
        println(out, "<script type=\"text/javaScript\">");
        //--- new TelosysEnv(...)
        generateTelosysEnv(out, getScreenMap());
        if (_sVarActions != null)
        {
            println(out, "  var " + _sVarActions + " = telosys.getCurrentActions(); ");
        }
        if (_sVarScreen != null)
        {
            println(out, "  var " + _sVarScreen + " = telosys.getCurrentScreen(); ");
        }
        if (_sVarKeyboard != null)
        {
            println(out, "  var " + _sVarKeyboard + " = telosys.getKeyboard(); ");
        }
        if (_sVarBrowser != null)
        {
            println(out, "  var " + _sVarBrowser + " = telosys.getBrowser(); ");
        }
        println(out, "</script>");

        //      TODO : Store the variables names

        return (SKIP_BODY);
    }

    private void generateTelosysEnv(JspWriter out, ScreenMap screenMap)
    {
        String sMsg = "// Cannot init with current screen ";
        String sTelosysVar = "telosys";

        //--- Get the URLs
        String sRootURL = TagCommons.getRootContextURL(pageContext);
        String sScreenmapURL = TagCommons.getScreenMapURL(pageContext);
        String sAjaxURL = TagCommons.getScreenActionURL(pageContext);

        //--- Current Screen Name and Screen ID
        String sScreenName = null;
        int iScreenId = -1;
        if (screenMap != null)
        {
            //--- Current screen name & screen id
            sScreenName = screenMap.getName();
            iScreenId = screenMap.getScreenContextId();
            if (sScreenName == null)
            {
                println(out, sMsg + "( Screen name == null )");
            }
            if (iScreenId < 0)
            {
                println(out, sMsg + "( Screen id == " + iScreenId + ")");
            }
        }
        else
        {
            println(out, sMsg + "( no ScreenMap )");
        }

        print(out, "  var " + sTelosysVar + " = new TelosysEnv( \"" + sRootURL + "\", \"" + sScreenmapURL + "\", \"" + sAjaxURL + "\"");
        if (sScreenName != null && iScreenId >= 0)
        {
            println(out, ", \"" + sScreenName + "\", " + iScreenId + " ) ; ");
        }
        else
        {
            println(out, " ) ; ");
        }
    }

    /***************************************************************************************************************************************************************************************************
     * private boolean generateVarActions( JspWriter out, ScreenMap screenMap ) { String sMsg = "// Cannot generate 'actions' variable " ; if (screenMap == null) { println(out, sMsg + "( no ScreenMap
     * )") ; return false ; }
     * 
     * //--- Current screen name & screen id String sScreenName = screenMap.getName() ; int iScreenId = screenMap.getScreenContextId(); if ( sScreenName == null ) { println(out, sMsg + "( Screen name ==
     * null )") ; return false ; } if ( iScreenId < 0 ) { println(out, sMsg + "( Screen id == " + iScreenId + ")") ; return false ; }
     * 
     * String sVarName = _sVarActions ; if ( sVarName == null ) { sVarName = "actions" ; } println(out, " var " + sVarName + " = telosys.getActions( '" + sScreenName + "', " + iScreenId + "); " );
     *  // TODO : Store the variable name
     * 
     * return true ; }
     **************************************************************************************************************************************************************************************************/
}