package org.objectweb.telosys.uil.taglib.util;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.Finder;
import org.objectweb.telosys.uil.taglib.Page;

/**
 * @author Laurent GUERIN
 *  
 */
public class With extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String             _sBean = null ;

    private String             _sScope = null ;

    public void setBean(String v)
    {
        this._sBean = v;
    }

    public void setScope(String v)
    {
        this._sScope = v;
    }

    //----------------------------------------------------------------
    
    private boolean setCurrentBean()
    {
        if (_sBean == null)
        {
            tagLibMessage("Cannot get bean (no bean attribute)");
            return false;
        }
        else
        {
            Object oBean = null ;
            try
            {
                oBean = Finder.find(pageContext, _sBean, _sScope);
            } catch (TelosysException e) 
            {
                tagLibMessage("Cannot get bean : RuntimeException : " + e.getMessage() );
            }
            
            if (oBean != null)
            {
                //--- Found => set as current bean
                Page.setCurrentBean(pageContext, oBean);
                return true;
            }
            else
            {
                //--- Not found => no current bean
                Page.clearCurrentBean(pageContext);
                tagLibMessage("Cannot get bean ('" + _sBean + "' not found)");
                return false;
            }
        }
    }

    //----------------------------------------------------------------
    //----------------------------------------------------------------
    public int doStartTag()
    {
        setCurrentBean();
        return (EVAL_BODY_INCLUDE);

//        if (setCurrentBean())
//        {
//            return EVAL_BODY_INCLUDE;
//        }
//        else
//        {
//            return SKIP_BODY;            
//        }
    }

    //----------------------------------------------------------------
    public int doEndTag()
    {
        Page.clearCurrentBean(pageContext);
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
//    //----------------------------------------------------------------
//    public int doAfterBody()
//    {
//        System.out.println("Iterate : doAfterBody() ");
//        if (nextItem())
//        {
//            return EVAL_BODY_AGAIN;
//        }
//        return SKIP_BODY;
//    }
//    //----------------------------------------------------------------
}