package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ButtonHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.ButtonXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class Button extends GenericTag
{
    protected static final String TAG_NAME = "button";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen  = new ButtonHTML();

    private final static IWidget  $xulGen   = new ButtonXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    protected String              _sTxt    = "xxx";

    protected String              _sImgSrc = null;

    protected String              _sImgPos = "left";

    protected String              _sSpacer = "4";

    /**
     * Constructor
     */
    public Button()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setTxt(String v)
    {
        _sTxt = v;
    }

    public String getTxt()
    {
        return _sTxt;
    }

    //----------------------------------------------------------------
    public void setImgsrc(String v)
    {
        _sImgSrc = v;
    }

    public String getImgsrc()
    {
        return _sImgSrc;
    }

    //----------------------------------------------------------------
    public void setImgpos(String v)
    {
        _sImgPos = v;
    }

    public String getImgpos()
    {
        return _sImgPos;
    }

    //----------------------------------------------------------------
    public void setSpacer(String v)
    {
        _sSpacer = v;
    }
    public void setSpacer(int v)
    {
        _sSpacer = ""+v;
    }
    public String getSpacer()
    {
        return _sSpacer;
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        //        JspWriter out = pageContext.getOut();
        //        try
        //        {
        //            if (TagCommons.isHTML(pageContext))
        //            {
        //                htmlGen.startTag(out,this);
        //            }
        //            else
        //            {
        //                xulGen.startTag(out,this);
        //            }
        //        } catch (IOException ioex)
        //        {
        //            ioex.printStackTrace();
        //        }
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
}