package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ContainerHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.ContainerXUL;


/**
 * @author Laurent GUERIN
 *  
 */
public class Container extends GenericTag
{
    private static final String  TAG_NAME = "container";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new ContainerHTML();

    private final static IWidget $xulGen  = new ContainerXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    /**
     * Constructor
     */
    public Container()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    // Ouverture du TAG
    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    // Fermeture du TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
}
