package org.objectweb.telosys.uil.taglib.widget;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author Laurent GUERIN
 *  
 */
public class Default extends TagSupport
{
    private static final String TAG_NAME   = "default";

    private String              _sTag      = null;

    //--- The attributes accepting default values
    private String              _sCl       = null;

    private String              _sStyle    = null;

    private String              _sDisabled = null;

    public void setTag(String v)
    {
        _sTag = v;
    }

    public void setCl(String v)
    {
        _sCl = v;
    }

    public void setStyle(String v)
    {
        _sStyle = v;
    }

    public void setDisabled(boolean v)
    {
        _sDisabled = "" + v;
    }

    public void setDisabled(String v)
    {
        _sDisabled = v;
    }

    public void trace(JspWriter out, String s)
    {
        try
        {
            out.println("<!-- default : tag = '" + _sTag + "' : " + s + " -->");
        } catch (IOException e)
        {
            // Nothing to do
        }
    }

    public int doStartTag()
    {
        if (_sTag != null)
        {
            JspWriter out = pageContext.getOut();

            TagScreenEnv screenEnv = TagCommons.getScreenEnv(pageContext);
            if (_sCl != null)
            {
                screenEnv.setDefaultAttributeValue(_sTag, "cl", _sCl);
                trace(out, "cl = '" + _sCl + "'");
            }
            if (_sStyle != null)
            {
                screenEnv.setDefaultAttributeValue(_sTag, "style", _sStyle);
                trace(out, "style = '" + _sStyle + "'");
            }
            if (_sDisabled != null)
            {
                screenEnv.setDefaultAttributeValue(_sTag, "disabled", _sDisabled);
                trace(out, "disabled = '" + _sDisabled + "'");
            }
        }
        return (SKIP_BODY);
    }
}