package org.objectweb.telosys.uil.taglib.widget;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.common.data.ApplicationDataHolder;
import org.objectweb.telosys.common.data.ListItemProvider;
import org.objectweb.telosys.uil.taglib.TagCommons;
import org.objectweb.telosys.uil.taglib.widget.html.GenericItemsListHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.GenericItemsListXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class GenericItemsListTag extends GenericTag 
{
    //private static final String TAG_NAME = "comboitems";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static GenericItemsListHTML  $htmlGen  = new GenericItemsListHTML();

    private final static GenericItemsListXUL   $xulGen   = new GenericItemsListXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String              _sProvider   = "xxx";

    /**
     * Constructor
     */
//    public GenericItemsListTag()
//    {
//        super(TAG_NAME, null, null);
//    }
    public GenericItemsListTag(String sTagName)
    {
        super(sTagName, null, null);
    }

    //----------------------------------------------------------------
    public void setProvider(String v)
    {
        _sProvider = v;
    }
    public String getProvider()
    {
        return _sProvider ;
    }

    //----------------------------------------------------------------
    // 
    //----------------------------------------------------------------
    public int doStartTag()
    {
        boolean bHtmlType = TagCommons.isHTML(pageContext);

        JspWriter out = pageContext.getOut();

        //--- Get the Application Data
        ListItemProvider listItem = ApplicationDataHolder.getListItemProvider(_sProvider);
        if (listItem != null)
        {
            	listItem.beforeUse();
                int iRowCount = listItem.getRowCount();
                String sVal = "";
                String sTxt = "???";
                //--- Generate each item as a "combo item"
                for ( int iRow = 1 ; iRow <= iRowCount ; iRow++ )
                {
                    sVal = listItem.getListItemValue(iRow);
                    sTxt = listItem.getListItemText(iRow);
                    //--- Print the list item 
                    printItem(out, bHtmlType, iRow, sVal, sTxt );
                }
            	listItem.afterUse();
        }
        else
        {
            printItem(out, bHtmlType, 0, "", "ERROR : unknown 'data' " );
        }
        
        return (SKIP_BODY);
    }
    
    /**
     * Prints a given item of the list provider
     * @param out
     * @param bHtmlType
     * @param iRow
     * @param sVal
     * @param sTxt
     */
    private void printItem(JspWriter out, boolean bHtmlType, int iRow, String sVal, String sTxt) 
    {
        try
        {
            if (bHtmlType)
            {
                $htmlGen.printItem(out, this, iRow, sVal, sTxt);
            }
            else
            {
                $xulGen.printItem(out, this, iRow, sVal, sTxt);
            }
        } catch (IOException ioex)
        {
            ioex.printStackTrace();
        }
    }    
}