package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ImageHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.ImageXUL;

/**
 * @author Laurent GUERIN
 *  
 */

public class Image extends GenericTag
{
    private static final String  TAG_NAME = "image";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new ImageHTML();

    private final static IWidget $xulGen  = new ImageXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String               _sAlt    = null;

    private String               _sSrc    = "";

    private String               _sCres   = "";

    /**
     * Constructor
     */
    public Image()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setAlt(String v)
    {
        _sAlt = v;
    }

    public String getAlt()
    {
        return _sAlt;
    }

    //----------------------------------------------------------------
    public void setSrc(String v)
    {
        _sSrc = v;
    }

    public String getSrc()
    {
        return _sSrc;
    }

    //----------------------------------------------------------------
    public void setCres(String v)
    {
        _sCres = v;
    }

    public String getCres()
    {
        return _sCres;
    }

    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
    public String getFullImageSrc()
    {
        return getFullImageSrc(_sCres);
//        if (_sSrc != null)
//        {
//            return TagCommons.getImgDirURL(pageContext) + _sSrc;
//        }
//        else
//        {
//            return "";
//        }
    }
}