package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.LabelHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.LabelXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class Label extends GenericTag
{
    private static final String TAG_NAME = "label";
    
    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new LabelHTML();

    private final static IWidget $xulGen  = new LabelXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    private String              _sTxt    = "xxx";

    private String              _sFor    = null ;

    /**
     * Constructor 
     */
    public Label()
    {
        super(TAG_NAME, $htmlGen, $xulGen);        
    }
    
    //----------------------------------------------------------------
    public void setTxt(String v)
    {
        _sTxt = v;
    }
    public String getTxt()
    {
        return _sTxt;
    }
    
    //----------------------------------------------------------------
    public void setFor(String v)
    {
        _sFor = v;
    }
    public String getFor()
    {
        return _sFor ;
    }

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        return (SKIP_BODY);
    }
}
