/*
 * Created on 27 juin 2005
 *
 */
package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.TagCommons;
import org.objectweb.telosys.uil.taglib.widget.html.LinkHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.LinkXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class Link extends GenericTag
{
    private static final String TAG_NAME = "link";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new LinkHTML();

    private final static IWidget $xulGen  = new LinkXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String              _sTxt    = null;

    private String              _sHref    = null;

    private String              _sCres    = null;

    private String              _sTarget  = null;

    /**
     * Constructor
     */
    public Link()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setTxt(String v) 
    {
        _sTxt = v;
    }
    public String getTxt() 
    {
        return _sTxt ;
    }

    //----------------------------------------------------------------
    public void setHref(String v) 
    {
        _sHref = v;
    }
    public String getHref() 
    {
        return _sHref;
    }

    //----------------------------------------------------------------
    public void setCres(String v) 
    {
        _sCres = v;
    }
    public String getCres() 
    {
        return _sCres;
    }

    //----------------------------------------------------------------
    public void setTarget(String v) 
    {
        _sTarget = v;
    }
    public String getTarget() 
    {
        return _sTarget;
    }

    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
    public String getFullContextRef()
    {
        if (_sCres != null)
        {
            String sCref = _sCres.trim();
            //--- Remove the starting "/" if any
            if ( sCref.startsWith("/") )
            {
                sCref = sCref.substring(1);
            }
            return TagCommons.getRootContextURL(pageContext) + "/" + sCref;
        }
        else
        {
            return "";
        }
    }
}