package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ListBoxHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.ListBoxXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class ListBox extends GenericPostbackTag // GenericTag 
{
    private static final String  TAG_NAME   = "listbox";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen   = new ListBoxHTML();

    private final static IWidget $xulGen    = new ListBoxXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String               _sSize     = "3";

    private String               _sMultiple = null;

    /**
     * Constructor
     */
    public ListBox()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setSize(String v)
    {
        _sSize = v;
    }

    public void setSize(int v)
    {
        _sSize = "" + v;
    }

    public String getSize()
    {
        return _sSize;
    }

    //----------------------------------------------------------------
    public void setMultiple(String v)
    {
        _sMultiple = v;
    }

    public void setMultiple(boolean v)
    {
        if (v == true)
        {
            _sMultiple = "true";
        }
    }

    public String getMultiple()
    {
        return _sMultiple;
    }

    public boolean isMultiple()
    {
        if (_sMultiple != null)
        {
            if (_sMultiple.trim().equalsIgnoreCase("true"))
            {
                return true;
            }
        }
        return false;
    }

    //----------------------------------------------------------------
    public String getValue() // Overrides the standard method to use POSTBACK
    {
        trace("getValue()...");
        String sValue = getValueWithPostback();
        trace("getValue() : return " + sValue );
        return sValue;
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    // Fermeture du TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    //----------------------------------------------------------------
}