package org.objectweb.telosys.uil.taglib.widget;

import javax.servlet.jsp.tagext.TagSupport;

import org.objectweb.telosys.uil.taglib.TagCommons;

/**
 * @author T. Poingt, L. Guerin
 *  
 */
public class Set extends TagSupport
{
    //----------------------------------------------------------------
    // Constants
    //----------------------------------------------------------------
    private static final String TAG_NAME   = "set";

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String              _sVarName  = null;

    private String              _sVarValue = null;

    private String              _sXValue   = null;

    private String              _sYValue   = null;

    /**
     * Set "var" attribute
     * 
     * @param v
     */
    public void setVar(String v)
    {
        _sVarName = v;
    }

    /**
     * Set "value" attribute
     * 
     * @param v
     */
    public void setValue(String v)
    {
        _sVarValue = v;
    }

    /**
     * Set "x" attribute
     * 
     * @param v
     */
    public void setX(String v)
    {
        _sXValue = v;
    }

    /**
     * Set "y" attribute
     * 
     * @param v
     */
    public void setY(String v)
    {
        _sYValue = v;
    }

    //----------------------------------------------------------------
    // Tag processing
    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        if (_sVarName != null && _sVarValue != null)
        {
            setVariable(_sVarName, _sVarValue);
        }
        else if (_sXValue != null)
        {
            setVariable(Variables.X, _sXValue);
        }
        else if (_sYValue != null)
        {
            setVariable(Variables.Y, _sYValue);
        }
        else
        {
            TagCommons.printError(pageContext, "SET : No valid attributes !");
        }
        return (SKIP_BODY);
    }

    private void setVariable(String sVarName, String sVarValue)
    {
        Variables variables = Variables.getVariables(pageContext);
        if (variables != null)
        {
            variables.set(sVarName, sVarValue);
        }
        else
        {
            TagCommons.printError(pageContext, "SET : Cannot get the variables !");
        }
    }
}