package org.objectweb.telosys.uil.taglib.widget;

import javax.servlet.jsp.tagext.Tag;

import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.widget.html.TabPanelHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.TabPanelXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class TabPanel extends GenericTag
{
    protected static final String TAG_NAME = "tabpanel";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen = new TabPanelHTML();

    private final static IWidget  $xulGen  = new TabPanelXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    /**
     * Constructor
     */
    public TabPanel()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public int getNextIndex()
    {
        return Page.getNextTabIndex(pageContext);
    }
    
    //----------------------------------------------------------------
    public String getPanelClass()
    {
        if ( getCl() != null )
        {
            return getCl() ;
        }
        else
        {
            TabPanels parent = getParentTabPanels();
            if (parent != null)
            {
                return parent.getCl();
            }            
        }
        return null;
    }

    //----------------------------------------------------------------
    public TabPanels getParentTabPanels()
    {
        Tag parentTag = getParent();
        if (parentTag != null)
        {
            if (parentTag instanceof TabPanels)
            {
                return (TabPanels) parentTag;
            }
            else
            {
                error("Parent tag is not an instance of TabPanels");
            }
        }
        else
        {
            error("Cannot get parent (TabPanels) ");
        }
        return null;
    }


    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }

    //----------------------------------------------------------------
}