package org.objectweb.telosys.uil.taglib.widget;

import javax.servlet.jsp.tagext.Tag;

import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.uil.taglib.TagConst;
import org.objectweb.telosys.uil.taglib.widget.html.TabPanelsHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.TabPanelsXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class TabPanels extends GenericTag
{
    protected static final String TAG_NAME = "tabpanels";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen = new TabPanelsHTML();

    private final static IWidget  $xulGen  = new TabPanelsXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    /**
     * Constructor
     */
    public TabPanels()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    private void applyDefaults()
    {
        if (getCl() == null)
        {
            setCl(TagConst.TABPANELS_DEFAULT_CL);
        }
    }

    //----------------------------------------------------------------
    private void reset()
    {
        setCl(null);
    }

    //----------------------------------------------------------------
    public TabBox getParentTabBox()
    {
        Tag parentTag = getParent();
        if (parentTag != null)
        {
            if (parentTag instanceof TabBox)
            {
                return (TabBox) parentTag;
            }
        }
        return null;
    }

    //----------------------------------------------------------------
    public String getTabBoxWidth()
    {
        TabBox parentTabBox = getParentTabBox();
        if (parentTabBox != null)
        {
            return parentTabBox.getWidth();
        }
        else
        {
            error("Cannot get parent TabBox");
        }
        return null;
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        applyDefaults();
        Page.initTabIndex(pageContext);
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();
        reset();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    //----------------------------------------------------------------
}