package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.Button;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * HTML generation for Button widget 
 * 
 * @author Laurent GUERIN
 *  
 */
public class ButtonHTML extends GenericHTML implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Button tag = (Button) genericTag ;
        //Recuperation des attributs
        //String sTxt = getAttributeValue("txt", _sTxt);
        String sTxt = tag.getTxt() ;
        //String sImgSrc = getAttributeValue("imgsrc", _sImgSrc);
        String sImgSrc = tag.getImgsrc() ;

        //--- Open the tag : <button>
        out.print("<button "
        + getIdAttr(tag)+ " "
        + getClassAttr(tag)+" "
        + getStyleAttr(tag)+" "
        + getTitleAttr(tag)+" " 
        + getTabindexAttr(tag)+" " );
        if (tag.isDisabled())
        {
            out.print(" disabled=\"disabled\" ");
        }
        
        //--- Events set for this tag
        tag.printEvents(out);
        out.print(" >");
        

        //--- If the button has an image ...
        if (sImgSrc != null)
        {
//            String sImgPos = getAttributeValue("imgpos", _sImgPos);
//            String sSpacer = getAttributeValue("spacer", _sSpacer);
            String sImgPos = tag.getImgpos() ;
            String sSpacer = tag.getSpacer() ;

            if ("left".equalsIgnoreCase(sImgPos))
            {
                out.print("<img ");
                out.print("style=\"margin-right:" + sSpacer + "px;\"");
                out.print(" src=\"" + sImgSrc + "\"");
                out.print("/>");
                out.print(sTxt);
            }
            else if ("right".equalsIgnoreCase(sImgPos))
            {
                out.print(sTxt);
                out.print("<img ");
                out.print("style=\"margin-left:" + sSpacer + "px;\"");
                out.print(" src=\"" + sImgSrc + "\"");
                out.print("/>");
            }
            else if ("top".equalsIgnoreCase(sImgPos))
            {
                out.print("<img ");
                out.print("style=\"margin-bottom:" + sSpacer + "px;\"");
                out.print(" src=\"" + sImgSrc + "\"");
                out.print("/>");
                out.print("<br>");
                out.print(sTxt);
            }
            else if ("bottom".equalsIgnoreCase(sImgPos))
            {
                out.print(sTxt);
                out.print("<br>");
                out.print("<img ");
                out.print("style=\"margin-top:" + sSpacer + "px;\"");
                out.print(" src=\"" + sImgSrc + "\"");
                out.print("/>");
            }
        }
        else
        {
            out.print(sTxt);
        }

        out.print("</button>");
    }    
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
    }
    //----------------------------------------------------------------
}
