package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.Hidden;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * HTML generation for Hidden tag
 * 
 * @author Laurent GUERIN
 *  
 */
public class HiddenHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Hidden tag = (Hidden) genericTag;

        out.print("<input type=\"hidden\" ");
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        out.print(getStyleAttr(tag) + " ");
        if (tag.getName() != null)
        {
            out.print(" name=\"" + tag.getName() + "\" ");
        }
        //out.print(" value=\"" + sValue + "\" />");
        if (tag.getValue() != null)
        {
            out.print(" value=\"" + tag.getValue() + "\" ");
        }                
        out.println(" />");
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Hidden tag = (Hidden) genericTag;
        //--- Register the current field via Javascript ...
        registerField(tag);
    }

    //----------------------------------------------------------------
    private void registerField(Hidden tag) 
    {
        if (needRegister(tag))
        {
            String sFirstArgs = firstArgsToRegister(tag);
            String sJavascript = "RegisterHidden(" + sFirstArgs + ")";
            tag.addJavascriptLine(sJavascript);
        }
    }
}