package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.Image;

/**
 * HTML generation for Image widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ImageHTML extends GenericHTML implements IWidget 
{

    //----------------------------------------------------------------

    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Image tag = (Image) genericTag ;

        String sSrc = tag.getSrc() ;
        String sCRes = tag.getCres() ;
        String sAlt = tag.getAlt() ;

        if ( voidOrNull(sSrc) && voidOrNull(sCRes) )
        {
            //TagCommons.printError(out, "No attribute src or cres ");
            tag.error("No attribute src or cres ");
            return ;
        }
        
        out.print("<img ");
        out.print( getIdAttr(tag)+ " " );
        out.print( getClassAttr(tag)+" " );
        out.print( getStyleAttr(tag)+" " );
        out.print( getTitleAttr(tag)+" " );
        if ( notVoid(sCRes) )
        {
            //--- Print the full context URL 
            out.print(" src=\"" + tag.getFullImageSrc() + "\" ");
        }
        else
        {
            //--- Print the standard "src" ( as is )
            out.print(" src=\"" + tag.getSrc() + "\" ");
        }
        if ( sAlt != null )
        {
            out.print(" alt=\"" + sAlt + "\" ");
        }
        
        //--- Events set by user
        tag.printEvents(out);

        out.print("/>");
        
        out.println("");
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
    }

}