package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.Label;

/**
 * HTML generation for Label widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class LabelHTML extends GenericHTML implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Label tag = (Label) genericTag ;

        String sTxt = tag.getTxt() ;
        String sFor = tag.getFor() ; 

        out.print("<label ");
        out.print( getIdAttr(tag)+ " " );
        out.print( getClassAttr(tag)+" " );
        out.print( getStyleAttr(tag)+" " );
        out.print( getTitleAttr(tag)+" " );
        if ( sFor != null )
        {
            out.print(" for=\"" + sFor + "\" ");            
        }        
        out.print(">");
        //-- Text 
        out.print( ( sTxt != null ? sTxt : "" ) );
        //--- End of tag
        out.print("</label>");
        
        out.println("");
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
    }
}