package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.ListBox;

/**
 * HTML generation for ListBox widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ListBoxHTML extends GenericHTML implements IWidget 
{

    //----------------------------------------------------------------

    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        ListBox tag = (ListBox) genericTag ;
        
        String sSize = tag.getSize();
        //--- Open the tag 
        out.print("<select " 
        + getIdAttr(tag)+ " "
        + getClassAttr(tag)+" "
        + getStyleAttr(tag)+" "
        + getTitleAttr(tag)+" " 
        + getTabindexAttr(tag)+" " );
        
        if (tag.getName() != null)
        {
            out.print(" name=\"" + tag.getName() + "\"");
        }        
        
        if ( sSize != null )
        {
            out.print(" size=\"" + sSize + "\" ");
        }
        if ( tag.isMultiple() )
        {
            out.print(" multiple =\"multiple\" ");
        }
        if (tag.isDisabled())
        {
            out.print(" disabled=\"disabled\" ");
        }

        //--- Events set for this tag
        tag.printEvents(out);
        out.println(" >");
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        //--- Close the tag 
        out.println("</select>");
        ListBox tag = (ListBox) genericTag ;
        //--- Register the current field via Javascript ...
        registerField(tag);        
    }
    //----------------------------------------------------------------
    private void registerField(ListBox tag) 
    {
        if (needRegister(tag))
        {
            String sFirstArgs = firstArgsToRegister(tag);
            String sJavascript = "RegisterListBox(" + sFirstArgs + ")";
            tag.addJavascriptLine(sJavascript);
        }
    }

    //----------------------------------------------------------------
}