package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.RadioGroup;

/**
 * HTML generation for RadioGroup widget
 * 
 * @author Laurent GUERIN
 *  
 */

public class RadioGroupHTML extends GenericHTML implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag( JspWriter out, GenericTag genericTag ) throws IOException 
    { 
        RadioGroup tag = (RadioGroup) genericTag ;

      //--- Open the tag  
      out.print( "<div " 
	      + getIdAttr(tag)+ " "
	      + getClassAttr(tag)+" "
	      + getStyleAttr(tag)+" "
	      //+ getTitleAttr(tag)+" " 
	      //+ getTabindexAttr(tag)+" " 
	      );
      
      //--- Events set for this tag
      //tag.printEvents(out);
      out.print(" >");
      
    }  
    //----------------------------------------------------------------
    public void endTag( JspWriter out, GenericTag genericTag ) throws IOException 
    {
      //--- Close the tag
      out.print( "</div>");
      //--- Register the current field via Javascript ...
      RadioGroup tag = (RadioGroup) genericTag;
      registerField(out,tag);
    }
    //----------------------------------------------------------------
    private void registerField(JspWriter out, RadioGroup tag) throws IOException
    {
        if (needRegister(tag))
        {
            String sJavascript = "" ;
            String sFirstArgs = firstArgsToRegister(tag);

            //--- Build the radio items array 
            String sRadioItemsArray = buildRadioItemsArray(tag) ;
            if ( sRadioItemsArray != null )
            {
                //--- Build the Javascript line ...
                sJavascript = "RegisterRadioGroup(" + sFirstArgs + ", " + sRadioItemsArray + ")";                    
            }
            else
            {
                sJavascript = "// " + tag.getId() + " : no radio items => not registered";                    
            }
            tag.addJavascriptLine(sJavascript);
        }        
    }
    //----------------------------------------------------------------
    private String buildRadioItemsArray(RadioGroup tag) 
    {
        String sRadioItemsArray = null ;
        LinkedList items = tag.getRadioItemsId() ;
        if ( items != null )
        {
            if ( items.size() > 0 )
            {
                Iterator it = items.iterator();
                if ( it != null )
                {
                    int i = 0 ;
                    sRadioItemsArray = "new Array(" ;
                    String sRadioItemId = null ;
                    while ( it.hasNext() )
                    {
                        i++;
                        if ( i > 1 )
                        {
                            sRadioItemsArray += "," ;                                    
                        }
                        sRadioItemId = (String) it.next() ;
                        sRadioItemsArray += "\"" + sRadioItemId + "\"" ;
                    }
                    sRadioItemsArray += ")" ;
                }
            }
        }
        return sRadioItemsArray ;
    }
}
