package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.TabPanel;

/**
 * HTML generation
 * 
 * @author Laurent GUERIN
 *  
 */
public class TabPanelHTML extends GenericHTML implements IWidget
{
    private final static String DIV_STYLE = "position:absolute;top:0px;left:0px;height:100%;width:100%;visibility:hidden;" ;

    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        TabPanel tag = (TabPanel) genericTag;
        int iTabIndex = tag.getNextIndex(); // From 0 to N 
        out.println("<!-- TabPanel [" + iTabIndex + "] --> ");
        out.print("<div ");
        out.print(getIdAttr(tag) + " ");
        //out.print(getSpecificClassAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        out.print(getSpecificStyleAttr(tag) + " ");
        out.print(" >");

    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.println("</div>");
    }
    //----------------------------------------------------------------
    private String getSpecificStyleAttr(GenericTag tag)
    {
        String s = getStyleFragUserStyle(tag) + DIV_STYLE ; 
        s = s.trim() ;
        if ( s.length() > 0 )
        {
            return "style=\"" + s + "\"";                    
        }
        else
        {
            return "";                                
        }
    }
    //----------------------------------------------------------------
//    private String getSpecificClassAttr(TabPanel tag)
//    {
//        String sClass = tag.getPanelClass();
//        if (sClass != null)
//        {
//            return "class=\"" + sClass + "\"";
//        }
//        else
//        {
//            return "";
//        }
//    }
    //----------------------------------------------------------------    
}
