package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.JSLines;
import org.objectweb.telosys.uil.taglib.TagConst;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.Tabs;

/**
 * Widget HTML generator
 * 
 * @author Laurent GUERIN
 *  
 */
public class TabsHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Tabs tag = (Tabs) genericTag;

//        //--- Tag <table ... >
//        out.print("<table ");
//        //out.print(getIdAttr(tag) + " ");
//        out.print(getClassAttr(tag) + " ");
//        //out.print(getStyleAttr(tag) + " ");
//        out.print(" >");

        //--- Tag <tr ... >
        out.print("<tr ");
        String sAlign =  tag.getAlign() ;
        if ( sAlign != null )
        {
            out.print(" align=\"" + sAlign + "\" ");            
        }
        //out.print(getClassAttr(tag) + " ");
        //out.print(getStyleAttr(tag) + " ");
        out.println(" >");
        
        //--- Tag <td ... >
        out.print(" <td ");
        String sStyle = TagConst.CSS_STYLE_LAYOUT ;
        String sWidthVal = tag.getTabBoxWidth(); // From parent tag "tabbox"
        if ( sWidthVal != null )
        {
            sStyle = TagConst.CSS_STYLE_LAYOUT + "; width:" + sWidthVal + "px;";
        }
        out.print(" style=\"" + sStyle + "\" ");            
        out.println(" >");

        //--- Tag <table ... >
        out.print("  <table ");
        out.print("style=\"" + TagConst.CSS_STYLE_LAYOUT + "\" ");            
        out.println(" >");

        //--- Tag <tr ... >
        out.print("   <tr ");
        String sHeight = tag.getHeight();
        if (sHeight != null)
        {
            out.print(" style=\"height:" + sHeight + "px\" ");
        }
        out.println(" >");

        //--- External Left Spacer ?
        if (tag.hasLeftSpacer())
        {
            String sSpacerClass = tag.getLeftSpacerClass();
            if (sSpacerClass != null)
            {
                out.println("<td class=\"" + sSpacerClass + "\" ></td>");
            }
            else
            {
                out.println("<!-- No left spacer class : spacer not generated -->");
            }
        }
                
        String s = " var telosysTabSet = new TabSet( " 
            	+ " \"" + tag.getUnselectedClass()  + "\" , " 
            	+ " \"" + tag.getSelectedClass() + "\" );" ;

        JSLines.clearJSLines(tag.getPageContext(), JSLines.TABBOX);
        JSLines.addLine(tag.getPageContext(), JSLines.TABBOX, s);
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Tabs tag = (Tabs) genericTag;
        //--- External Right Spacer ?
        if (tag.hasRightSpacer())
        {
            String sSpacerClass = tag.getRightSpacerClass();
            if (sSpacerClass != null)
            {
                out.println("<td class=\"" + sSpacerClass + "\" ></td>");
            }
            else
            {
                out.println("<!-- No right spacer class : spacer not generated -->");
            }
        }
        //--- Close TR and TABLE
        out.println("   </tr>");
        out.println("  </table>");
        out.println(" </td>");
        out.println("</tr>");
        
    }
    //----------------------------------------------------------------
}