package org.objectweb.telosys.uil.taglib.widget.xul;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.GroupBox;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * XUL generation for GroupBox widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class GroupBoxXUL extends GenericXUL implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        GroupBox tag = (GroupBox) genericTag;
        String sTxt = tag.getTxt();

        out.print( "<groupbox " );
        out.print(getIdAttr(tag) + " ");
//        out.print(getClassAttr(tag) + " ");
//        out.print(getStyleAttr(tag) + " ");
//        out.print(getTitleAttr(tag) + " ");
        out.print(" >");
        
        //--- Caption if any
        if (sTxt != null)
        {
            out.print( "<caption label=\"" + sTxt + "\" />" );          
        }
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.print( "</groupbox>");
    }
    //----------------------------------------------------------------
}