package org.objectweb.telosys.util;

import org.objectweb.telosys.common.TelosysException;

/**
 * @author Laurent GUERIN
 *  
 */

public class Cast
{

    public static Object toObject(String s, int iType) throws TelosysException
    {
        if ( s == null )
        {
            return null ;
        }
        
        try 
        {
            switch (iType)
            {
            case Const.BOOLEAN :
                return Boolean.valueOf(s); // "true" (ignore case) / other = false

            case Const.BYTE :
                return Byte.valueOf(s);
            case Const.DOUBLE :
                return Double.valueOf(s);
            case Const.FLOAT :
                return Float.valueOf(s);
            case Const.INTEGER :
                return Integer.valueOf(s);
            case Const.LONG :
                return Long.valueOf(s);
            case Const.SHORT :
                return Short.valueOf(s);
            case Const.STRING :
                return s;

            case Const.DATE :
                return java.sql.Date.valueOf(s); // ""yyyy-mm-dd" ( throws IllegalArgumentException )

            default :
                throw new TelosysException("Cast.toObject() : Unknowned type " + iType);
            }
        } catch (NumberFormatException e)
        {
            throw new TelosysException("Cast.toObject() : Invalid number '" + s + "' ", e);
        } catch (IllegalArgumentException e)
        {
            throw new TelosysException("Cast.toObject() : Invalid date (ISO) '" + s + "' ", e);
        }
    }
}