package org.objectweb.telosys.util;

/**
 * @author Laurent GUERIN
 *
 */
public final class NumUtil
{
    /** */
    private NumUtil()
    {
    }

    /**
     * Mthode permettant de formater un nombre de type int en le forant 
     * afficher un nombre donn de caractres.
     * @param iNbr Le nombre de type int  formater
     * @param iLength La taille minimum de ce nombre (nombre de chiffres)
     * @param bFixedSize True si la taille est fixe
     * @param cAppended Le caractre ventuellement ajout au dbut de la chaine
     * pour obtenir un nombre en taille fixe (ex: '0' ou ' ')
     * @return String
     */
    public static String formatInt(final int iNbr, final int iLength, final boolean bFixedSize, final char cAppended)
    {
        String s = String.valueOf(iNbr);
        int iDiff = s.length() - iLength;
        if (iDiff > 0 && bFixedSize) // le nombre est plus long que la taille souhaite
        {
            return s.substring(0, iLength);
        }
        else if (iDiff < 0) // le nombre est moins long que la taille souhaite
        {
            iDiff = iDiff * -1;
            StringBuffer sb = new StringBuffer();
            for (int i = 0; i < iDiff; i++)
            {
                sb.append(cAppended);
            }
            return sb.append(s).toString();
        }
        return s;
    }

    /**
     * 
     * @param iNbr :
     * @param iMinLength :
     * @return String :
     */
    public static String formatInt(final int iNbr, final int iMinLength)
    {
        return formatInt(iNbr, iMinLength, false, '0');
    }

}