package org.objectweb.telosys.util.web;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Laurent GUERIN
 *  
 */
public final class ShowFileServlet extends HttpServlet
{

    private String sDirectory = "" ;
    
	/**
	 * @see javax.servlet.GenericServlet#init()
	 */
	public void init() throws ServletException
	{
	    // TODO : init file directory 
	    sDirectory = "" ;
	}

	/**
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public void doGet(final HttpServletRequest request, final HttpServletResponse response) throws ServletException, IOException
	{
		process(request, response);
	}

	/**
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public void doPost(final HttpServletRequest request, final HttpServletResponse response) throws ServletException, IOException
	{
		process(request, response);
	}

	/**
	 * @see javax.servlet.Servlet#destroy()
	 */
	public void destroy()
	{
	}

	/**
	 * 
	 * @param request :
	 * @param response :
	 * @throws ServletException :
	 * @throws IOException :
	 */
	private void process(final HttpServletRequest request, final HttpServletResponse response) throws ServletException, IOException
	{
		response.setContentType("text/plain");
		PrintWriter out = response.getWriter();
		String sFileName = request.getParameter("file");
		if (sFileName != null)
		{
			String sLongFileName = sDirectory + sFileName ;
			printFile(sLongFileName, out);
		}
		else
		{
			out.write("\n\n No file name parameter ! \n\n");
		}
	}

	/**
	 * @param sFileName :
	 * @param out :
	 * @throws ServletException :
	 * @throws IOException :
	 */
	private void printFile(final String sFileName, final PrintWriter out) throws ServletException, IOException
	{
		FileReader fr = null;
		try
		{
			fr = new FileReader(sFileName);
			char[] buffer = new char[1024];
			int len = 0;
			while ((len = fr.read(buffer)) > 0)
			{
				out.write(buffer, 0, len);
			}
		}
		catch (FileNotFoundException e)
		{
			out.write("\n\nFile "+ sFileName + " not found ! \n\n");
		}
		finally
		{
			if (fr != null)
			{
				fr.close();
			}
		}
	}

}